/* ccsi_data_services.js */

(function($) {
    $.fn.changeElementType = function(newType) {
        var attrs = {};

        $.each(this[0].attributes, function(idx, attr) {
            attrs[attr.nodeName] = attr.nodeValue;
        });

        this.replaceWith(function() {
            return $("<" + newType + "/>", attrs).append($(this).contents());
        });
    };
})(jQuery);

// By default we use new scales
var useLegacyScales = false;

// brb - 2021-04-23: Automatically renumber questions so I don't have to do this
// manually in the XML.

var curr_question_num = 1;
$('[data-block_type="survey_question"]').each(function () {
    var $this = $(this);
    $this.attr('data-number', curr_question_num);
    curr_question_num++;
});


// brb: 2019-05-22

// temporary GLOBALS for testing

// the two variables below make this one obsolete
var DO_NOT_SAVE_DS = false;

// These two variables allow us to force fails on setData for testing
// whether the initial setData should fail
var INITIAL_DS_FAIL = false;
// whether the retry of setData should fail
var RETRY_DS_FAIL = false;

// brb: intentionally create error on DS save for testing
/*
if (window.parent.PX.API.DataService.setDataOrig === undefined) {
    window.parent.PX.API.DataService.setDataOrig = window.parent.PX.API.DataService.setData;
}
window.parent.PX.API.DataService.setDataTest = function(user_data) {
    //var url = window.parent.PX.API.DataService.brbGetBaseUrl() + "/setdata";

    var url = "/externalapi/" + parent.PxPage.dsapi_url.request_url + "/setdata";

    //safe_log("window.parent.PX.API.DataService.setData: " + url);
    //safe_log(user_data[0]);
    safe_log("setDataTest: error triggered");

    // passing 'true' as the first arg will cause brbCreatePromise to fail
    return window.parent.PX.API.DataService.brbGetPromise("setData error triggered intentionally", "POST", url, user_data);
}
*/

// ?debug=true&isInstructor=true

xBookUtils.printDebugStatements = 'on';

var xBookUtils = {};

// https://github.com/ftlabs/fastclick
// Enable FastClick library with hopes of fixing select list issue in iOS with VoiceOver
/*
$(function() {
    FastClick.attach(document.body);
});
*/

var serverURL = 'https://devlives.azurewebsites.net';
//jquery UI stubs to prevent errors

var noopApi = {
    initializeClass: function() {
        var dfd = jQuery.Deferred();
        setTimeout(function() {
            dfd.resolve(null);
        }, Math.floor(100 + Math.random() * 500));
        return dfd.promise();
    },
    initializeUser: function() {
        var dfd = jQuery.Deferred();
        setTimeout(function() {
            dfd.resolve(null);
        }, Math.floor(100 + Math.random() * 500));
        return dfd.promise();
    },
    loadClassData: function() {
        var dfd = jQuery.Deferred();
        setTimeout(function() {
            dfd.resolve([]);
        }, Math.floor(100 + Math.random() * 500));
        return dfd.promise();
    },
    loadGlobalClassData: function() {
        var dfd = jQuery.Deferred();
        setTimeout(function() {
            dfd.resolve(null);
        }, Math.floor(100 + Math.random() * 500));
        return dfd.promise();
    },
    setData: function() { safe_log("noopAPI.setData"); },
    setGlobalData: function() {
        var dfd = jQuery.Deferred();
        setTimeout(function() {
            dfd.resolve(null);
        }, Math.floor(100 + Math.random() * 500));
        return dfd.promise();
    },


};


jQuery.fn.extend({
    button: function() {},
    dialog: function() {}
});


Standard_Dialog.alert = function(message) {

    $('<div class=\'modal fade\'><div class=\'modal-dialog\'><div class=\'modal-content\'><div class=\'modal-header\'><button type=\'button\' class=\'close\' data-dismiss=\'modal\' aria-label=\'Close\'><span aria-hidden=\'true\'>&times</span></button><h4 class=\'modal-title\'>Notice:</h4></div><div class=\'modal-body\'>' + message + '</div><div class=\'modal-footer\'><button type=\'button\' class=\'btn btn-default\' data-dismiss=\'modal\'>Close</button></div></div></div></div>').modal('show');

    /*
    $('.modal-footer').find('button').focus();
    $('.modal-content').bind('keydown', function(e) {
        safe_log('modal caught keydown');
        var code = e.keyCode || e.which;
        if (!e.shiftKey && code === KEY_CODES.TAB) {
            $parentDialog.focus();
            e.preventDefault();
        }
    });
    */

};


//dom manipulations for Bootstrap styling
$(document).ready(function() {
    $('[data-type=chapter]').addClass('container');

    $('[data-block_type=row]').addClass('row');
});


$('[data-block_type=row]').each(function(index, element) {
    $(element).find('[data-type=box]').each(function(index, boxElement) {
        var block_type = $(boxElement).attr('data-block_type');
        if (block_type.indexOf('col') == 0) {
            //its a special column box and we need to set the bootstrap class
            $(boxElement).addClass(block_type);

        }

    });

});


$('[data-type=question]').addClass('form-group');



//global helper functions
function getParameterByName(name) {
    name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
    var regex = new RegExp('[\\?&]' + name + '=([^&#]*)'),
        results = regex.exec(location.search);
    return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
}



var Activity_gore = Activity_manuscript_type.extend({


    restore_saved_answers: function() {

        this._super();
        player.update_progress_bar();

    },
    submit_question: function(question_index) {


        // check if we are NOT saving DS data
        /*
        if ($('#ds_save_cb_1').length == 1 && $("#ds_save_cb_1")[0].checked) {
            DO_NOT_SAVE_DS = true;
        }
        else {
            DO_NOT_SAVE_DS = false;
        }
        */
        // brb: we are done with testing for now, always save
        DO_NOT_SAVE_DS = false;

        /*
        if ($('#initial_ds_fail').length == 1 && $("#initial_ds_fail")[0].checked) {
            INITIAL_DS_FAIL = true;
        }
        else {
            INITIAL_DS_FAIL = false;
        }

        if ($('#retry_ds_fail').length == 1 && $("#retry_ds_fail")[0].checked) {
            RETRY_DS_FAIL = true;
        }
        else {
            RETRY_DS_FAIL = false;
        }
        */

        //safe_log("INITIAL_DS_FAIL = " + INITIAL_DS_FAIL);
        //safe_log("RETRY_DS_FAIL = " + RETRY_DS_FAIL);

        // the arg may be a number or an event object; in the latter case...
        if (typeof question_index == 'object') {
            // extract the question_index from the object
            question_index = question_index.data.question_index;
        }
        //force all queries to be answered before doing anything.


        var allQueriesAnswered = true;


        for (var i = 0; i < player.activity.questions[question_index].queries.length; i++) {
            var x = player.activity.questions[question_index].queries[i].user_has_answered();

            // if the year of birth was bad then user_has_answered will return "BAD_BIRTH_YEAR" and at this point we can return false

            if (x === 'BAD_BIRTH_YEAR') {
                $('#query_answer_96').focus();
                return false;
            }

            if (!x) {
                allQueriesAnswered = false;

            }
        }



        if (!allQueriesAnswered) {

            //$("<div class='modal fade answer_questions_warning'><div class='modal-dialog'><div class='modal-content'><div class='modal-header'><button type='button' class='close' data-dismiss='modal' aria-label='Close'><span aria-hidden='true'>&times</span></button><h4 class='modal-title'>Please answer all questions</h4></div><div class='modal-body'>Please answer all of the questions before submitting.</div><div class='modal-footer'><button type='button' class='btn btn-default' data-dismiss='modal'>Close</button></div></div></div></div>").modal("show");

            alert('Please answer all of the questions on this page before submitting.');
            return false;

        }


        this._super(question_index);


        // the arg may be a number or an event object; in the latter case...
        if (typeof question_index == 'object') {
            // extract the question_index from the object
            question_index = question_index.data.question_index;
        }


        //loop through the queries in the question


        function getIndexFromMeasureKey(key) {

            for (var i = 0; i < player.measure_names.length; i++) {
                if (player.measure_names[i].key == key) {
                    return i;
                }
            }
            return -1;

        }

        // We don't need to do any of this since we will do it again in
        // send_ds_info().
        /*
        for (var i = 0; i < player.activity.questions[question_index].queries.length; i++) {

            var q = player.activity.questions[question_index].queries[i];
            if (typeof q.md.measure != 'undefined') {

                var measure_string = q.md.measure;
                var measures = measure_string.split(',');
                var measure = measures[0];
                var reverse = false;
                if (typeof q.md.reverse_score != 'undefined') {
                    if (q.md.reverse_score == 'true') {
                        reverse = true;
                    }
                }

                var index = getIndexFromMeasureKey(measure);

                if (reverse) {

                    player.measure_names[index].score = player.measure_names[index].score + (6 - player.activity.questions[question_index].queries[i].user_answer_index);

                } else {

                    player.measure_names[index].score = player.measure_names[index].score + player.activity.questions[question_index].queries[i].user_answer_index + 1;

                }

            }

            if (typeof q.md.demographic != 'undefined') {

                if (q.md.demographic === 'Birth year') {
                    player.demographic_data[q.md.demographic] = q.choices[q.user_answer_index].replace(',', '');
                } else {
                    player.demographic_data[q.md.demographic] = q.choices[q.user_answer_index].replace(',', '');
                }
            }
        }
        */


        player.update_progress_bar();

        // brb: This saves the student info to DS
        player.save_student_data();

        //player.activity.questions[question_index].checkModelUpdateConditionals(question_index);
        //var executedNextStep = player.activity.questions[question_index].checkNextStepConditionals(question_index);



        //player.sendModelToServer();


        //check if we need to show the next button

        $('#next_button').show();
        $('#next_button').attr('aria-hidden', 'false');
        player.show_section('next');

        return false;
    },

    ARGA_initialization_alert: function() {
        // This overrides the standard ARGA initialization message, which doesn't
        // tell the user he/she can resubmit (or tell him his grade)
        var grade = Get_ARGA_Grade();
        var due_date_passed = (Get_ARGA_Data('due_date_has_passed') == '1');
        var msg = '';
        var buttons;

        due_date_passed = false;

        if (grade != '' && grade != null && grade >= 0) {
            // if resubmissions are allowed...
            if (player.md.allow_resubmission == 'true') {
                // if due date has not passed, give the student the option of resubmitting or reviewing
                if (!due_date_passed) {
                    msg = '<p>You have completed this activity, and your grade (' + grade + '%) has been submitted. Would you like to:</p><ul>' +
                        '<li><b>Keep your current grade</b> and review your previous answers</li>' +
                        '<li>Or reset your submission and <b>try the activity again</b>?</li>' +
                        '</ul>';
                    buttons = [{
                        text: 'Keep current grade',
                        click: player.activity.ARGA_initialization_final
                    }, {
                        text: 'Try Activity Again',
                        click: function() {
                            player.activity.ARGA_initialization_final('reset');
                        }
                    }];

                } else {
                    msg = '<p>You have completed this activity, and your grade (' + grade + '%) has been submitted. Since the due date for the activity has now passed, you cannot re-submit answers to the activity questions.</p>';
                    buttons = [{
                        text: 'OK',
                        click: player.activity.ARGA_initialization_final
                    }];
                }

                // resubmissions are not allowed
            } else {
                //msg = "<p>You have completed this activity, and your grade (" + grade + "%) has been submitted.</p>"
                //    ;
                //buttons = [ {text:"OK", click: player.activity.ARGA_initialization_final} ];
                player.activity.ARGA_initialization_final();
            }

            // grade has not been submitted
        } else {
            // if due date has passed, tell the user "tough luck". Otherwise show nothing.
            if (due_date_passed) {
                msg = '<p>The due date for this activity has passed.  You can still review the activity, but no answers will be submitted and no grade will be recorded.</p>';
                buttons = [{
                    text: 'OK',
                    click: player.activity.ARGA_initialization_final
                }];
            }
        }

        // if we need a message, show it in a jquery UI dialog
        if (msg != '') {
            msg = '<div id=\'arga_init_dialog\'>' + msg + '</div>';
            $('body').append(msg);
            $('#arga_init_dialog').dialog({
                title: 'Please Note',
                width: 450,
                modal: true,
                buttons: buttons
            });
        } else {
            player.activity.ARGA_initialization_final();
        }
    }

});


var Player_gore = Player_manuscript_type.extend({

    ACTIVITY_COMPLETED: false,

    // array for storing autocomplete list of names
    autocompleteArray: [],

    scrolling_window_jq: null,

    cfg_LH_useOpenContent: 'on',

    // These are for printing the header
    px_student_name: undefined,
    px_instructor_name: undefined,
    px_term: undefined,
    px_assessment_date: undefined,

    /*
    measure_names:[
        {key:"critical_thinking",value: "Critical Thinking/Goal Setting"},
        {key:"motivation", value:"Motivation/Personal Responsibility"},
        {key:"learning_preferences", value:"Learning Preferences"},
        {key:"time_management", value:"Time Management"},
        {key:"reading", value:"Reading"},
        {key:"note_taking", value:"Note Taking"},
        {key:"memory", value:"Memory/Studying"},
        {key:"exam_performance", value:"Performing on Exams"},
        {key:"information", value:"Finding and Communicating Information"},
        {key:"interpersonal_skills", value:"Interpersonal Skills"},
        {key:"health", value:"Personal and Financial Health"},
        {key:"planning", value:"Academic and Career Planning"}
    ],



    survey_data:{
        critical_thinking:0,
        motivation: 0,
        learning_preferences: 0,
        time_management:0,
        reading:0,
        note_taking:0,
        memory:0,
        exam_performance:0,
        information:0,
        interpersonal_skills:0,
        health:0,
        planning:0


    },


    */
    isInstructor: true,
    questions: [],

    source_has_been_converted: false,

    get_question_data: function() {

        $('[data-block_type=survey_question]').each(function(index, element) {
            var qText = $(element).find('.query_text').html();
            var query = player.activity.queries[i];
            var scale = query.md.measure;

            questions.push({
                questionText: qText,
                scale: scale
            });



        });

    },

    class_data: {},

    demographic_keys: [
        'gender_identity',
        'hispanic_origin',
        'American Indian or Alaskan Native',
        'Asian',
        'Black or African American',
        'Native Hawaiian or Other Pacific Islander',
        'White',
        'International or foreign national',
        'Started college at this institution',
        'Current college credits',
        'Enrolled for 12 or more credits',
        'Birth year',
        'Parents highest level of education',
        'Expected level of education',
        'First person to attend college',
        'Eligible for Federal Pell Grant',
        'Serve in US Military'
    ],

    measure_names: [
        {
            key: '2',
            value: 'Critical Thinking/Goal Setting',
            score: 0
        },
        {
            key: '3',
            value: 'Motivation/Decision Making/Personal Responsibility',
            score: 0
        },
        {
            key: '4',
            value: 'Learning Preferences',
            score: 0
        },
        {
            key: '5',
            value: 'Organization/Time Management',
            score: 0
        },
        {
            key: '6',
            value: 'Reading',
            score: 0
        },
        {
            key: '7',
            value: 'Note Taking',
            score: 0
        },
        {
            key: '8',
            value: 'Memory/Studying',
            score: 0
        },
        {
            key: '9',
            value: 'Test Taking',
            score: 0
        },
        {
            key: '10',
            value: 'Information Literacy and Communication',
            score: 0
        },
        {
            key: '11',
            value: 'Connecting with Others',
            score: 0
        },
        {
            key: '12',
            value: 'Personal and Financial Health',
            score: 0
        },
        {
            key: '13',
            value: 'Academic and Career Planning',
            score: 0
        },
        {
            key: '91',
            value: 'Critical Thinking/Goal Setting - NEW',
            score: 0
        },
        {
            key: '92',
            value: 'Academic and Career Planning - NEW',
            score: 0
        },
        {
            key: '93',
            value: 'Learning Preferences - NEW',
            score: 0
        },
        {
            key: '94',
            value: 'Connecting with Others - NEW',
            score: 0
        },
        {
            key: '95',
            value: 'Academic and Career Planning - NEW',
            score: 0
        },
        {
            key: '99',
            value: 'Online Learning - NEW',
            score: 0
        },
    ],

    measure_names_new: [
        {
            key: '2',
            value: 'Goal Setting',
            score: 0
        },
        {
            key: '3',
            value: 'Academic and Financial Planning',
            score: 0
        },
        {
            key: '4',
            value: 'Motivation, Decision Making, and Personal Responsibility',
            score: 0
        },
        {
            key: '5',
            value: 'Organization and Time Management',
            score: 0
        },
        {
            key: '6',
            value: 'Learning/Critical Thinking',
            score: 0
        },
        {
            key: '7',
            value: 'Reading',
            score: 0
        },
        {
            key: '8',
            value: 'Note Taking',
            score: 0
        },
        {
            key: '9',
            value: 'Memory and Studying',
            score: 0
        },
        {
            key: '10',
            value: 'Test Taking',
            score: 0
        },
        {
            key: '11',
            value: 'Information Literacy and Communication',
            score: 0
        },
        {
            key: '12',
            value: 'Social Belonging',
            score: 0
        },
        {
            key: '13',
            value: 'Health/Wellness',
            score: 0
        },
        {
            key: '14',
            value: 'Career Readiness',
            score: 0
        },
        {
            key: '15',
            value: 'Online Learning',
            score: 0
        },
        {
            key: '99',
            value: 'Not used',
            score: 0
        }
    ],

    demographic_data: {},

    survey_data: {
        2: 0,
        3: 0,
        4: 0,
        5: 0,
        6: 0,
        7: 0,
        8: 0,
        9: 0,
        10: 0,
        11: 0,
        12: 0,
        13: 0,
        91: 0,
        92: 0,
        93: 0,
        94: 0,
        95: 0,
    },
    
    // new data for Summer 2019
    table: {
        2: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 9, 13, 18, 25, 33, 43, 53, 64, 74, 81, 87, 91, 95, 99],
        3: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 5, 7, 9, 13, 17, 22, 28, 35, 42, 51, 59, 67, 74, 81, 87, 92, 96, 99],
        4: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 9, 12, 17, 22, 28, 35, 42, 49, 55, 62, 69, 75, 80, 84, 88, 91, 94, 96, 97, 98, 99, 99],
        5: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 11, 14, 18, 23, 27, 32, 38, 43, 49, 54, 59, 64, 69, 73, 77, 80, 84, 87, 89, 92, 94, 95, 97, 97, 98, 99, 99, 99],
        6: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 11, 14, 18, 24, 30, 37, 45, 53, 62, 70, 78, 84, 89, 92, 95, 97, 98, 99],
        7: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 5, 7, 9, 11, 14, 18, 22, 27, 33, 40, 47, 55, 63, 70, 78, 83, 88, 91, 94, 96, 98, 99],
        8: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 12, 16, 22, 29, 38, 47, 57, 66, 75, 83, 89, 92, 95, 97, 98, 99],
        9: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 5, 7, 9, 12, 16, 20, 26, 32, 38, 46, 54, 61, 69, 77, 83, 87, 90, 93, 95, 97, 99],
        10: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 5, 6, 9, 11, 15, 19, 24, 30, 36, 43, 50, 57, 64, 71, 77, 83, 87, 91, 94, 96, 97, 98, 99],
        11: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 11, 14, 18, 24, 30, 37, 45, 53, 61, 69, 75, 82, 87, 91, 94, 96, 98, 98, 99],
        12: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 5, 7, 9, 12, 15, 20, 24, 30, 36, 43, 49, 56, 63, 69, 76, 81, 86, 90, 93, 95, 97, 98, 99, 99, 99],
        13: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 3, 4, 6, 8, 10, 13, 16, 21, 26, 31, 37, 43, 49, 55, 62, 68, 74, 80, 84, 89, 92, 94, 96, 98, 99],
        91: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 9, 13, 18, 25, 33, 43, 53, 64, 74, 81, 87, 91, 95, 99],
        92: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 3, 4, 6, 8, 10, 13, 16, 21, 26, 31, 37, 43, 49, 55, 62, 68, 74, 80, 84, 89, 92, 94, 96, 98, 99],
        93: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 9, 12, 17, 22, 28, 35, 42, 49, 55, 62, 69, 75, 80, 84, 88, 91, 94, 96, 97, 98, 99, 99],
        94: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 11, 14, 18, 24, 30, 37, 45, 53, 61, 69, 75, 82, 87, 91, 94, 96, 98, 98, 99],
        95: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 3, 4, 6, 8, 10, 13, 16, 21, 26, 31, 37, 43, 49, 55, 62, 68, 74, 80, 84, 89, 92, 94, 96, 98, 99],
        99: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 3, 4, 6, 8, 10, 13, 16, 21, 26, 31, 37, 43, 49, 55, 62, 68, 74, 80, 84, 89, 92, 94, 96, 98, 99],
    },

    table_new: {
        2: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 12, 14, 19, 24, 24, 31, 40, 55, 64, 71, 83, 88, 93, 98, 99],
        3: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 5, 7, 7, 12, 14, 19, 21, 24, 36, 43, 48, 52, 60, 64, 79, 88, 88, 93, 93, 95, 95, 95, 98, 99],
        4: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 5, 7, 9, 13, 17, 22, 28, 35, 42, 51, 59, 67, 74, 81, 87, 92, 96, 99],
        5: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 11, 14, 18, 23, 27, 32, 38, 43, 49, 54, 59, 64, 69, 73, 77, 80, 84, 87, 89, 92, 94, 95, 97, 97, 98, 99, 99, 99],
        6: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 7, 10, 10, 17, 24, 24, 31, 38, 48, 60, 67, 79, 83, 86, 90, 98, 98, 99],
        7: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 11, 14, 18, 24, 30, 37, 45, 53, 62, 70, 78, 84, 89, 92, 95, 97, 98, 99],
        8: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 5, 7, 9, 11, 14, 18, 22, 27, 33, 40, 47, 55, 63, 70, 78, 83, 88, 91, 94, 96, 98, 99],
        9: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 4, 6, 8, 12, 16, 22, 29, 38, 47, 57, 66, 75, 83, 89, 92, 95, 97, 98, 99],
        10: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 3, 5, 7, 9, 12, 16, 20, 26, 32, 38, 46, 54, 61, 69, 77, 83, 87, 90, 93, 95, 97, 99],
        11: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 3, 5, 6, 9, 11, 15, 19, 24, 30, 36, 43, 50, 57, 64, 71, 77, 83, 87, 91, 94, 96, 97, 98, 99],
        12: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 7, 21, 21, 26, 36, 43, 52, 57, 60, 64, 79, 88, 93, 93, 95, 98, 99, 99, 99],
        13: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 5, 5, 7, 12, 19, 21, 21, 21, 38, 45, 52, 64, 64, 74, 76, 81, 83, 93, 93, 95, 95, 98, 99, 99, 99, 99, 99, 99],
        14: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 5, 7, 7, 17, 17, 17, 21, 26, 31, 36, 38, 43, 48, 55, 57, 64, 69, 79, 83, 86, 90, 95, 95, 95, 98, 99],
        15: [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 4, 5, 6, 7, 11, 13, 18, 22, 29, 37, 49, 61, 70, 79, 85, 89, 92, 95, 99]
    },

    class_results_sort_order: 'book',
    roster_results_sort_order: 'name',
    toggle_instructor_results_details: function(shortName) {

        var $results_category = $('#instructor_results_category_' + shortName);
        var $results_details = $('#instructor_results_details_' + shortName);

        var aria_expanded = $results_category.attr('aria-expanded');
        var aria_hidden = $results_details.attr('aria-hidden');

        if (aria_expanded === 'false') {
            $results_category.attr('aria-expanded', 'true');
        } else {
            $results_category.attr('aria-expanded', 'false');
        }

        if (aria_hidden === 'false') {
            $results_details.attr('aria-hidden', 'true');
        } else {
            $results_details.attr('aria-hidden', 'false');
        }

        //$("#instructor_results_details_" + shortName).toggle();
        $results_details.toggle();

        // if we expanded this (it was originally 'false') then set focus on the h3
        if (aria_expanded === 'false') {
            $results_details.find('h3').focus();
        }

    },
    toggle_results_details: function(shortName) {

        var $results_category = $('#results_category_' + shortName);
        var $results_details = $('#results_details_' + shortName);

        var aria_expanded = $results_category.attr('aria-expanded');
        var aria_hidden = $results_details.attr('aria-hidden');

        if (aria_expanded === 'false') {
            $results_category.attr('aria-expanded', 'true');
            $results_category.find('a').attr('aria-expanded', 'true');
        } else {
            $results_category.attr('aria-expanded', 'false');
            $results_category.find('a').attr('aria-expanded', 'false');
        }

        if (aria_hidden === 'false') {
            $results_details.attr('aria-hidden', 'true');
        } else {
            $results_details.attr('aria-hidden', 'false');
        }

        /* Accessibility fix: hide the categories that aren't being shown from screen reader */
        /* We don't need to do this here any more since we are removing the unused
           categories when we first load the HTML into the page. */
        /*
        var catArray = [".low_category_info",".mid_category_info",".high_category_info"];
        for (var i = 0; i < catArray.length; i++) {

            var $cat = $results_details.find(catArray[i]);
            if ($cat.length > 0) {
        	if (!($cat.hasClass('active'))) {
        	    $cat.attr('aria-hidden', 'true');
        	}
            }
        }
        */

        //$("#results_details_" + shortName).toggle();
        $results_details.toggle();

        // if we just expanded this then set focus to <h4>
        if (aria_hidden === 'true') {
            //safe_log("h4");
            //safe_log($results_details.find('h4'));
            $results_details.find('h4').focus();
        }


    },

    // Expand all the details
    toggle_student_ranks: function() {
        var $toggle_link = $('#toggle_student_ranks');
        var expanded = $toggle_link.attr('aria-expanded');

        if (expanded === 'false') {
            $('.results_details').show().attr('aria-hidden', 'false');

            $('.results_row').each(function() {
                var $this = $(this);
                $this.attr('aria-expanded', 'true');
                $(this).find('a').attr('aria-expanded', 'true');
            });
            $toggle_link.attr('aria-expanded', 'true');
            $toggle_link.text('Collapse All Ranks');
        } else {
            $('.results_details').hide().attr('aria-hidden', 'true');
            $('.results_row').each(function() {
                var $this = $(this);
                $this.attr('aria-expanded', 'false');
                $(this).find('a').attr('aria-expanded', 'false');
            });
            $toggle_link.attr('aria-expanded', 'false');
            $toggle_link.text('Expand All Ranks');
        }
    },

    // Hide all the details
    hide_student_ranks: function() {
        $('.results_details').hide().attr('aria-hidden', 'true');
        $('.results_row').attr('aria-expanded', 'false');
        $('#hide_student_ranks').hide().attr('aria-hidden', 'true');
        $('#toggle_student_ranks').show().attr('aria-hidden', 'false').focus();
    },


    // called from submit_question
    save_student_data: function() {

        var scoreObject = {};

        // loop through each entry in measure_names array
        // we don't need to do this since we are only going to save
        // data to DS on the final submit
        /*
        for (var i = 0; i < player.measure_names.length; i++) {

            var score = 0;

            // get the score for the measure
            score = player.measure_names[i].score;

            // set scoreObject.key to score
            scoreObject[player.measure_names[i].key] = score;

        }
        */

        //safe_log("scoreObject:");
        //safe_log(JSON.stringify(scoreObject));

        // brb: if we are on the last page then we want to call send_ds_info
        // to make sure that we save the most up-to-date info in DS
        if (player.get_current_section().index == 10) {
            //safe_log("Last slide of questions, calling send_ds_info(1)");
            send_ds_info(1);
        } else {
            // send_student_data_to_ARGA has nothing to do with ARGA and just
            // sends sends the current info to DS. We don't need incremental
            // updates to DS, we only need to do it once when all questions
            // have been answered, which is done above when we reach index 10
            // and call send_ds_info.
            /*
            this.send_student_data_to_ARGA(scoreObject);

            if (player.ARGA_running) {
                scoreObject.courseID = Get_ARGA_Data('course_id');
            } else {
                scoreObject.courseID = 'DebugCourse';
            }

            this.sendModelToServer(scoreObject);
            */
        }

    }, // end save_student_data

    ds: {

        isInitialized: false,
        api: (typeof((((window.parent || {}).PX || {}).API || {}).DataService) != 'undefined') ? window.parent.PX.API.DataService : noopApi,

        generateDataRecord: function(datasetID, key, value, loadOnUserInit, loadOnClassInit, loadOnSchoolInit) {

            // Note: PX returns a Term ID with a space in it but the
            // loadInstitutionalData method breaks if there is a space
            // in the Term ID, so we need to remove the space from the 
            // Term ID before we save it with the student data.

            // Removed UserId from below because setData automatically
            // sets UserId to PxPage.Context.User.RAId no matter what 
            // we pass in for UserId, so we don't need to pass in 
            // a UserId
            // UserId: parent.PxPage.Context.User.CurrentUserId,

            var r = {
                CourseId: parent.PxPage.Context.Course.EntityId,
                InstitutionId: parent.PxPage.Context.Course.Domain.Id,
                TermId: getPXTermId(),
                InstructorId: parent.PxPage.Context.Course.CourseOwner.Id,
                Key: key,
                Value: {
                    v: JSON.stringify(value)
                },
                DataSetId: datasetID,
                LoadOnUserInit: loadOnUserInit,
                LoadOnClassInit: loadOnClassInit,
                LoadOnSchoolInit: loadOnSchoolInit

            };
            return r;

        },
        classData: {},
        userData: {},

        numReturned: 0,

        initialize: function(callback) {

            //safe_log("ds.initialize");

            // overwrite DataService API for testing purposes
            // set this to 1 if you want to intentionally introduce errors
            // for testing
            /*
            if (0) {

                safe_log("overwriting DataService API");

                window.parent.PX.API.DataService.brbGetPromise = function(err, type, url, data) {
                    var deferred = new $.Deferred();
                    if (err) {
                        deferred.reject(err);
                    } else {
                        window.parent.PX.API.DataService.brbAjaxCall(type, url, deferred, data);
                    }
                    return deferred;
                }

                window.parent.PX.API.DataService.brbAjaxCall = function(type, url, deferred, data) {

                    //safe_log("DataService.brbAjaxCall: type = " + type + ", url = " + url);
                    //safe_log(deferred);
                    //safe_log(JSON.stringify(data));

                    // brb: add args to fail so we can pass any error in the promise
                    $.ajax({
                        type: type,
                        url: url,
                        data: JSON.stringify(data),
                        contentType: "application/json; charset=utf-8",
                        dataType: "json"
                    }).done(function (s) {
                        deferred.resolve(s);
                    }).fail(function (jqXHR, textStatus, errorThrown) {
                        deferred.reject(jqXHR, textStatus, errorThrown);
                    });

                }

                window.parent.PX.API.DataService.initializeUser = function() {

                    // brb: this would normally be passed into the function
                    var datasetid = "aces";

                    var url = window.parent.PX.API.DataService.brbGetBaseUrl() + '/user/' + datasetid + '/' + parent.PxPage.Context.Course.EntityId;
                    return window.parent.PX.API.DataService.brbGetPromise(false, "GET", url);

                }

                window.parent.PX.API.DataService.initializeClass = function() {

                    // brb: this would normally be passed into the function
                    var datasetid = "aces";

                    var url = window.parent.PX.API.DataService.brbGetBaseUrl() + '/class/' + datasetid + '/' + parent.PxPage.Context.Course.EntityId;

                    return window.parent.PX.API.DataService.brbGetPromise(false, "GET", url);
                }

                window.parent.PX.API.DataService.brbGetBaseUrl = function() {

                    var url = "/externalapi/" + parent.PxPage.dsapi_url.request_url;

                    // brb: For testing purposes, mangle URL to dataservices so it triggers an error
                    var random = Math.floor((Math.random() * 4) + 1);
                    if (random > 3) {
                        safe_log("DataService.brbGetBaseUrl: random error triggered");
                        url = url.replace(/dataservices/, "dsvcs");
                    }

                    return url;
                }


            } // end if for overwriting
            */

            //safe_log(window.parent.PX.API.DataService);

            //safe_log(callback.toString());

            /*
            if (player.ARGA_running) {
                try {
                    var dejs_arr = ARGA_API.dejs_data;
                    for (var i=0; i<dejs_arr.length; i++) {
                        if (dejs_arr[i].name === "cmi.completion_status") {
                            this.ACTIVITY_COMPLETED = (ARGA_API.dejs_data[i].value == "completed");
                            safe_log("ACTIVITY_COMPLETED = " + this.ACTIVITY_COMPLETED);
                            break;
                        }
                    }
                }
                catch(err) {
                    safe_log("initialize2: Can't get cmi.completion_status: " + err)
                }
            }
            */

            document.title = 'ACES Inventory';

            this.initializeUser(function() { /*player.ds.numReturned++;*/
                checkNumReturned();
            });

            // this should only be called by the instructor
            if (player.isInstructor) {
                //safe_log("instructor: calling initializeClass");
                this.initializeClass(function() { /*player.ds.numReturned++;*/
                    checkNumReturned();
                });
            }

            // execute the callback function if numReturned > 0
            function checkNumReturned() {
                //safe_log("checkNumReturned");

                // If this is an instructor then both initializeUser and initializeClass
                // should have been successful
                if (player.isInstructor) {
                    //safe_log("player.ds.numReturned = " + player.ds.numReturned);
                    if (player.ds.numReturned > 1) {
                        callback();
                    } else {

                    }
                }
                // If this is a student then only initializeUser needs to be successful
                else {
                    //safe_log("player.ds.numReturned = " + player.ds.numReturned);
                    if (player.ds.numReturned > 0) {
                        callback();
                    } else {
                        alert('There was an error retrieving your data. Please exit out of this activity and then open it again to resume.');
                    }
                }
            }
        }, // end initialize

        initializeUser: function(callback) {

            this.api.initializeUser('aces').then(
                function(a) {

                    safe_log("initializeUser");
                    safe_log(a);

                    if (a != null) {

                        //safe_log("initializeUser (1)");
                        //safe_log(a);

                        for (var i = 0; i < a.length; i++) {
                            //safe_log(a[i].Key);
                            //safe_log(a[i].Value.v);

                            // brb: This should be in a try/catch block
                            // and then we log any errors but we don't have
                            // a way to log in PX right now
                            player.ds.userData[a[i].Key] = (JSON.parse(a[i].Value.v));
                            //safe_log(player.ds.userData[a[i].Key]);
                        }
                    }
                    // get assessment date for printing results
                    try {
                        if (player.ds.userData['scores'].assessmentDate !== undefined) {
                            player.px_assessment_date = player.ds.userData['scores'].assessmentDate;
                        }
                    }
                    catch(e) {}
                    player.ds.numReturned++;
                    //safe_log("initializeUser: numReturned = " + player.ds.numReturned);
                    //safe_log(player.ds.userData);

                    callback();
                },
                function(a, b, c) {

                    if (typeof a === 'object') {
                        a = JSON.stringify(a);
                    } else if (a === undefined) {
                        a = '';
                    }
                    b = b === undefined ? '' : b;
                    c = c === undefined ? '' : c;

                    alert('There was an error retrieving your data. Please exit out of this activity and then open it again to resume.');

                    brbDisableActivity('initializeUser failed', a, b, c);

                }
            ); // end then()

        }, // end initializeUser


        initializeClass: function(callback) {

            this.api.initializeClass('aces').then(
                function(a) {

                    //safe_log("initializeClass");
                    //safe_log(a);

                    if (a !== null && a !== undefined) {

                        for (var i = 0; i < a.length; i++) {

                            if (typeof player.ds.classData[a[i].Key] == 'undefined') {
                                player.ds.classData[a[i].Key] = [];
                            }

                            try {
                                var tempObj = JSON.parse(a[i].Value.v);
                                //safe_log("tempObj for " + i);
                                //safe_log(tempObj);

                                var isComplete = parseInt(tempObj.isComplete);
                                //safe_log("isComplete: " + isComplete);

                                // add object to end of classData array if isComplete
                                if (isComplete !== 0) {
                                    player.ds.classData[a[i].Key].push(JSON.parse(a[i].Value.v));
                                }
                            } catch (e) {
                                // brb: This would be an error I would like to
                                // log but we don't have a way to do this in PX
                                // at the moment
                                //safe_log("Skipping " + a[i].Value.v);
                                //safe_log(e.message)
                            }
                        }
                    }
                    player.ds.numReturned++;
                    //safe_log("initializeClass: numReturned = " + player.ds.numReturned);
                    //safe_log("initializeClass successful");
                    //safe_log(player.ds.classData);
                    callback();
                    this.isInitialized = true;
                },
                function(a, b, c) {
                    if (typeof a === 'object') {
                        a = JSON.stringify(a);
                    }

                    alert('There was an error retrieving your data. Please exit out of this activity and then open it again to resume.');

                    brbDisableActivity('initializeClass failed', a, b, c);
                }
            ); // end then()

        }, // end initializeClass


        getClassData: function(key) {
            var results = [];
            if (typeof this.classData[key] != 'undefined') {
                for (var i = 0; i < this.classData[key].length; i++) {

                    results.push(this.classData[key][i]);
                }
            }

            return results;
        }



    },

    // brb: The retry arg will be set to 1 if this is a retry of a
    // failed attempt to write to DS

    send_student_data_to_ARGA: function(data, retry) {

        if (retry != 1) {
            retry = 0;
        }

        //safe_log("send_student_data_to_ARGA: retry = " + retry);

        if (player.ARGA_running) {

            //Set_ARGA_Data("scores", JSON.stringify(data));
            //Set_ARGA_Data("demographics", JSON.stringify(player.demographic_data));
            //Save_ARGA_Data();

            //data services:
            var dataObject = {};
            dataObject.name = Get_ARGA_Data('learner_name');
            // brb: we aren't using the 'completion' status anywhere so
            // no use in storing it
            //dataObject.completion = Get_ARGA_Data("completion");

            /*
            if (dataObject.completion === undefined || dataObject.completion == "") {
                dataObject.completion = 0;
            }
            */

            dataObject.scores = data;
            dataObject.demographics = player.demographic_data;

            // if we are on the last page then send
            if (player.get_current_section().index == 10) {
                dataObject.isComplete = 1;
            } else {
                dataObject.isComplete = 0;
            }

            var courseOwner = getPXCourseOwnerID();
            var currentUser = getPXCurrentUserID();
            if (courseOwner !== undefined && currentUser !== undefined &&
                courseOwner === currentUser) {
                dataObject.isInstructor = 1;
            }
            else {
                dataObject.isInstructor = 0;
            }

            var record = player.ds.generateDataRecord('aces', 'scores', dataObject, 'true', 'true', 'false');

            //safe_log("send_student_data_to_ARGA: record");
            //safe_log(record);

            // brb - We only want to do this if all questions have been answered
            //if (player.get_current_section().index == 10) {
            //safe_log("current section is 10, sending DS record");

            // brb - Actually, we have to do this every time the student clicks Submit
            // so we can save what we currently have to DS in case the student leaves
            // before finishing (which will allow us to pick up where we left off).

            // brb: set to true for testing
            //DO_NOT_SAVE_DS = true;

            if (!DO_NOT_SAVE_DS) {
                //safe_log("saving DS data");

                // brb: for testing
                /*
                var fail = false;

                // if this is the initial attempt and INITIAL_DS_FAIL is
                // set to true then we want to fail
                if (retry == 0) {
                    if (INITIAL_DS_FAIL) {
                        fail = true;
                    }
                }
                // if this is the retry attempt and RETRY_DS_FAIL is
                // set to true then we want to fail
                else {
                    if (RETRY_DS_FAIL) {
                        fail = true;
                    }
                }

                if (!fail) {
                    window.parent.PX.API.DataService.setData = window.parent.PX.API.DataService.setDataOrig;
                }
                else {
                    window.parent.PX.API.DataService.setData = window.parent.PX.API.DataService.setDataTest;
                }
                */

                //safe_log("Saving DS data...");
                //safe_log(record);
                /*
                safe_log(window.parent.PX);
                safe_log(window.parent.PX.API);
                safe_log(window.parent.PX.API.DataService);
                safe_log(player.ds.api);
                */

                player.ds.api.setData([record]).then(
                    function(a) {
                        //safe_log("setData successful");
                        //safe_log(a);
                    },
                    function(a, b, c) {
                        //safe_log("setData failed");

                        // if this isn't a retry then wait a few seconds
                        // and try again
                        if (!retry) {
                            //safe_log("setData failed, retrying in 2 seconds");
                            //alert("setData failed, retrying in 2 seconds");
                            setTimeout(function() {
                                player.send_student_data_to_ARGA(data, 1);
                            }, 2000);
                        } else {
                            alert('There was an error saving your data. Please exit out of this activity and then open it again to resume.');

                            brbDisableActivity('setData error', a, b, c);
                        }
                    }
                );
            } else {
                safe_log('Not saving DS data');
                //alert("Student info was not saved to Data Services.");
            }

            //}
        }
    },

    class_scores: [],
    class_demographics: [],
    class_names: [],
    class_completion: [],

    get_class_data_from_ARGA: function() {

        if (player.ds.classData['scores'] != 'undefined') {
            //var scores = Get_ARGA_Data_Class("scores");
            //var demographics = Get_ARGA_Data_Class("demographics");
            //var names = Get_ARGA_Data_Class("learner_name");
            //var completion = Get_ARGA_Data_Class("complete");
            var scores = this.ds.getClassData('scores');


            for (var i = 0; i < scores.length; i++) {

                // brb: we don't use the completion status anywhere so
                // no use in saving it off
                //var completion = scores[i].completion;

                var object = {};
                object.name = scores[i].name.replace('%20', ' ');
                object.scores = scores[i].scores;
                object.demographics = scores[i].demographics;

                // brb
                //convert to percentile
                for (var key in object.scores) {
                    if (object.scores.hasOwnProperty(key)) {
                        object.scores[key] = player.table[key][object.scores[key]];
                    }

                }

                player.class_data[object.name] = object;

            }
        }

        //safe_log("class_data:");
        //safe_log(player.class_data);
        
    }, // end get_class_data_from_ARGA


    /* This just stores the DS object for the user on
       devlives.azurewebsites.net. I'm not sure what the purpose of this
       is, but this is what Adam gave me so I'll just leave it. */

    // brb: Note - this only sends if ARGA is running
    sendModelToServer: function(scoreObject) {

        var userID = 'debug';
        if (player.ARGA_running) {

            userID = encodeURIComponent(Get_ARGA_Data('learner_id'));
            userID = userID.replace('.', '_');

            //safe_log("sendModelToServer");
            //safe_log(scoreObject);
            //safe_log(serverURL + "/api/ACESvalues/" + userID);

            // brb: No 'Access-Control-Allow-Origin' header is present
            // on this server and thus this won't work, so just
            // disable it.

            /*
            $.ajax({
                type: 'POST',
                url: serverURL + '/api/ACESvalues/' + userID,
                contentType: 'application/json',
                data: JSON.stringify(scoreObject),
                success: function(data) {
                    //safe_log(data);
                }
            });
            */

        }

    }, // end sendModelToServer

    // brb: This loads the measure_names score data that has been saved to DS
    // so far.  That way if a student leaves the quiz before finishing and comes back
    // later we can start up where they left off.
    get_user_data_from_ARGA: function() {

        if (typeof player.ds.userData['scores'] != 'undefined') {

            var score = player.ds.userData['scores'].scores;

            for (var i = 0; i < player.measure_names.length; i++) {
                var measure = player.measure_names[i].key;

                player.measure_names[i].score = score[measure];

            }

            var score_new = player.ds.userData['scores'].scores_new;

            for (var j = 0; j < player.measure_names_new.length; j++) {
                var measure_new = player.measure_names_new[j].key;

                player.measure_names_new[j].score = score_new[measure_new];

            }

            console.log('player.measure_names: ', player.measure_names);
            console.log('player.measure_names_new: ', player.measure_names_new);

            player.generate_student_report($('[data-block_type=\'individual_student_results\']')[0]);
        }

    },

    generate_csv_filename: function(stem) {

        var courseID = 'courseID';
        var name = 'user';

        if (player.ARGA_running) {
            courseID = Get_ARGA_Data('course_id');
            name = Get_ARGA_Data('learner_name');
        }

        var nameParts = name.split(' ');
        var niceName = '';
        for (var i = 0; i < nameParts.length - 1; i++) {
            var letter = nameParts[i].substring(0, 1);
            niceName += letter + '-';
        }

        var lastName = nameParts[nameParts.length - 1];
        niceName += lastName;


        var d = new Date();
        var year = d.getFullYear();
        var month = d.getMonth() + 1;
        var day = d.getDate();

        if (month < 10) {
            month = '0' + month;
        }
        if (day < 10) {
            day = '0' + day;
        }


        var filename = 'ACES-' + stem + '_' + niceName + '_' + courseID + '_' + year + '-' + month + '-' + day + '.csv';
        return filename;

    },


    export_class_demographics_csv: function() {


        var csv = 'Name';

        for (var i = 0; i < player.demographic_keys.length; i++) {
            csv += ',' + player.demographic_keys[i];
        }


        for (var key in player.class_data) {
            if (player.class_data.hasOwnProperty(key)) {
                var student = player.class_data[key];

                // brb: remove any commas from student name
                var student_name = student.name;
                student_name = student_name.replace(/[,"]/g, "");
                
                
                // brb: we don't need the double quotes any more since
                // we are removing any commas from name
                //var line = '"' + student_name + '"' + ',';
                var line = student_name + ',';

                for (var i = 0; i < player.demographic_keys.length; i++) {
                    var demo = player.class_data[key].demographics[player.demographic_keys[i]];
                    
                    // demo may be undefined because we have added three
                    // new demo questions
                    if (demo !== undefined) {
                        // brb: parens from questions 98 & 99
                        demo = demo.replace(/ \(.*\)/,"");
                        // brb: remove any commas
                        demo = demo.replace(/[,"]/g, "");

                        // brb: we don't need the double quotes any more
                        // since we are removing all commas
                        //line += '"' + demo + '",';
                        line += demo + ',';
                    }
                }

                line = line.substring(0, line.length - 1);
                csv += '\n' + line;
            }
        }
        //safe_log("csv:");
        //safe_log(csv);
        var form = $('[data-block_type=hidden_form]').find('iframe');

        form.contents().find('#data').val(csv);
        var filename = player.generate_csv_filename('Demographics');
        form.contents().find('#file_name').val(filename);
        form.contents().find('#data_form').submit();



    },



    export_class_csv: function() {

        var csv = 'Name';

        for (var i = 0; i < player.measure_names.length; i++) {
            csv += ',' + player.measure_names[i].value;
        }

        for (var key in player.class_data) {
            if (player.class_data.hasOwnProperty(key)) {

                var student = player.class_data[key];
                
                // brb: remove any commas from student name
                var student_name = student.name;
                student_name = student_name.replace(/[,"]/g, "");

                // brb: we don't need the double quotes any more
                // since we are removing all commas
                //var line = '"' + student.name + '"' + ',';
                var line = student_name + ',';

                for (var scale in student.scores) {
                    if (student.scores.hasOwnProperty(scale)) {
                        line += student.scores[scale] + ',';
                    }



                }
                line = line.substring(0, line.length - 1);
                csv += '\n' + line;
            }
        }

        //safe_log(csv);
        var form = $('[data-block_type=hidden_form]').find('iframe');

        form.contents().find('#data').val(csv);
        var filename = player.generate_csv_filename('Results');
        form.contents().find('#file_name').val(filename);
        form.contents().find('#data_form').submit();

    },

    instructor_report_data_is_generated: false,
    entire_class_added: false,

    generate_instructor_report_data: function() {
        if (this.instructor_report_data_is_generated) {
            return;
        }
        //need to populate the student dropdown


        if (!this.entire_class_added) {
            this.autocompleteArray.push('Entire class');
            this.entire_class_added = true;
        }

        //var student_dropdown = $("#class_data_student_dropdown");
        for (var key in player.class_data) {
            if (player.class_data.hasOwnProperty(key)) {
                //student_dropdown.append("<option value='" + key + "'>" + key + "</option>");
                this.autocompleteArray.push(key);


                //also need to calculate an average for the stduent
                //no, we don't want averages, at least for now

                /*
                var totalPoints = 0;
                for(var s in player.class_data[key].scores){
                    if(player.class_data[key].scores.hasOwnProperty(s)){
                        totalPoints+= player.class_data[key].scores[s];

                    }
                }

                player.class_data[key].scores["total"] = (totalPoints / (player.measure_names.length)).toFixed(0);

                */
            }


        }

        //student_dropdown.select2();



        //add the topics
        var topicDropdown = $('#class_data_topic_dropdown');

        for (var i = 0; i < player.measure_names.length; i++) {
            topicDropdown.append('<option value=\'' + player.measure_names[i].key + '\'>' + player.measure_names[i].value + '</option>');
        }

        $('#class_data_student_dropdown').autocomplete({
            source: this.autocompleteArray,
            delay: 100,
            change: function(event, ui) {
                //safe_log("caught change in dropdown");

                var student = $('#class_data_student_dropdown').val();
                //safe_log(ui);
                //safe_log(ui.item.value);
                //var student = ui.item.value;
                if (student === 'entire class') {
                    student = 'Entire class';
                }

                var student_exists = false;
                var arr_count = player.autocompleteArray.length;
                for (var i = 0; i < arr_count; i++) {
                    if (player.autocompleteArray[i] === student) {
                        student_exists = true;
                        break;
                    }
                }

                if (student_exists) {
                    routie('user/' + encodeURIComponent($('#class_data_student_dropdown').val()));
                } else {
                    //safe_log("Can't find " + student + " in autocompleteArray (1)");
                    // don't need this one
                    //alert("Can't find student " + student + " in class report (1)");
                }
            }, // end change
            select: function(event, ui) {
                //safe_log("caught select");
                //safe_log(ui);
                //safe_log(ui.item.value);

                //var student = $("#class_data_student_dropdown").val();
                var student = ui.item.value;
                $('#class_data_student_dropdown').val(student);

                if (student === 'entire class') {
                    student = 'Entire class';
                }
                var student_exists = false;
                var arr_count = player.autocompleteArray.length;
                for (var i = 0; i < arr_count; i++) {
                    if (player.autocompleteArray[i] === student) {
                        student_exists = true;
                        break;
                    }
                }

                if (student_exists) {
                    routie('user/' + encodeURIComponent($('#class_data_student_dropdown').val()));
                } else {
                    //safe_log("Can't find " + student + " in autocompleteArray (2)");
                    alert('Can\'t find student ' + student + ' in class report');
                }
            } // end select
        });

        //this.instructor_report_data_is_generated = true;

    },


    generate_instructor_roster_report: function() {


        var container_element = $('[data-block_type=\'roster_results\']')[0];
        $(container_element).empty();


        var measure = player.current_topic;
        var rowCollection = [];



        for (var key in player.class_data) {
            if (player.class_data.hasOwnProperty(key)) {

                var html = '';
                var row = {};

                var shortName = player.class_data[key].name;
                var longName = shortName;
                row.percentage = player.class_data[key].scores[measure];
                row.shortName = shortName;
                var printStyle = '';
                var style = '';

                var range_text = '';

                if (row.percentage <= 25) {
                    style = 'progress-bar-danger';
                    printStyle = 'danger_color';
                    range_text = 'Low';
                } else if (row.percentage <= 75) {
                    style = 'progress-bar-warning';
                    printStyle = 'warning_color';
                    range_text = 'Moderate';
                } else {
                    style = 'progress-bar-success';
                    printStyle = 'success_color';
                    range_text = 'High';
                }

                //html += "<div class='row class_summary_row' onclick='player.toggle_instructor_results_details(\"" + shortName + "\");'>";
                html += '<div class=\'row class_summary_row\'>';
                html += '<div class=\'col-md-4 text-right-md\'><span><a href=\'#user/' + encodeURIComponent(longName) + '\'>' + longName + '</a></span></div>';
                html += '<div class=\'col-md-8\'><div class=\'progress\'>';


                /* Accessibility fix: we are removing the aria attributes and using just the html
                   to represent the score */

                //html += "<div class='progress-bar " + style + "' role='progressbar' aria-valuenow='" + row.percentage + "' aria-valuemin='0' aria-valuemax='100' style='min-width:2em; width:" + row.percentage + "%'><span class='bar_text'>" + row.percentage + "%</span><div class='" + printStyle + "'></div></div><div class='gray_color'></div>";

                html += '<div class=\'progress-bar ' + style + '\' style=\'min-width:2em; width:' + row.percentage + '%\'><span class=\'bar_text\'>' + row.percentage + '%</span><div class=\'' + printStyle + '\'><span class=\'visually-hidden\'>' + range_text + '</span></div></div><div class=\'gray_color\'></div>';



                html += '</div></div>';

                html += '<div class=\'row results_details\' id=\'instructor_results_details_' + shortName + '\'>';
                html += '<div class=\'col-md-4\'></div><div class=\'col-md-8 student_results_details\'>';

                html += '</div>';
                html += '</div>';


                html += '</div>';


                row.html = html;
                rowCollection.push(row);



            }
        }



        var sort_function = function(a, b) {
            if (a.shortName > b.shortName) {
                return 1;
            }
            if (a.shortName < b.shortName) {
                return -1;
            }
            return 0;
        };



        if (player.roster_results_sort_order == 'lowest') {
            sort_function = function(a, b) {
                return (a.percentage - b.percentage);
            };


        }


        if (player.roster_results_sort_order == 'highest') {
            sort_function = function(a, b) {
                return (b.percentage - a.percentage);
            };
        }


        rowCollection.sort(sort_function);


        var h = '';
        for (var i = 0; i < rowCollection.length; i++) {
            var row = rowCollection[i];
            h = h + row.html;

        }



        $(container_element).append(h);



    },


    // Class Report
    generate_instructor_report: function(container_element) {

        var container_element = $('[data-block_type=\'class_results_summary\']')[0];

        // we need to move this down after we validate that we have
        // good data for this user
        //$(container_element).empty();


        var rowOrder = [];
        var rowCollection = [];

        if (typeof player.current_student_for_report == 'undefined') {
            return false;
        }


        if (player.current_student_for_report == 'all' || player.current_student_for_report == 'Entire class' || player.current_student_for_report == 'entire class') {

            $(container_element).empty();

            for (var i = 0; i < player.measure_names.length; i++) {
                var html = '';
                var row = {};

                var shortName = player.measure_names[i].key;
                var longName = player.measure_names[i].value;


                row.shortName = shortName;
                row.longName = longName;
                var detail = '<h3 tabindex=\'-1\' style=\'outline: none\'>' + longName + '</h3>';

                var lowNames = [];
                var medNames = [];
                var highNames = [];

                //need to loop through students and count up the number in each category
                var numStudents = 0;
                var numLow = 0;
                var numMid = 0;
                var numHigh = 0;

                for (var key in player.class_data) {
                    if (player.class_data.hasOwnProperty(key)) {
                        numStudents++;
                        var score = player.class_data[key].scores[shortName];
                        if (score <= 25) {
                            numLow++;
                            lowNames.push(key);
                        } else if (score <= 75) {
                            numMid++;
                            medNames.push(key);
                        } else {
                            numHigh++;
                            highNames.push(key);
                        }

                    }
                }

                var lowPercentage = ((numLow / numStudents) * 100);
                var midPercentage = ((numMid / numStudents) * 100);
                var highPercentage = ((numHigh / numStudents) * 100);


                if (numStudents == 0) {
                    lowPercentage = 0;
                    midPercentage = 0;
                    highPercentage = 0;
                }
                row.lowPercentage = lowPercentage;
                row.midPercentage = midPercentage;
                row.highPercentage = highPercentage;


                var displaylowPercentage = lowPercentage.toFixed(0) + '%';
                var displaymidPercentage = midPercentage.toFixed(0) + '%';
                var displayhighPercentage = highPercentage.toFixed(0) + '%';
                //output the row
                detail += '<div role=\'tabpanel\'><ul class=\'nav nav-tabs\' role=\'tablist\'>';
                detail += '<li role=\'presentation\' class=\'active\'><a href=\'#' + shortName + '_low\' aria-controls=\'low scores\' role=\'tab\' data-toggle=\'tab\'>Low Ranks</a></li>';
                detail += '<li role=\'presentation\'><a href=\'#' + shortName + '_med\' aria-controls=\'medium scores\' role=\'tab\' data-toggle=\'tab\'>Moderate Ranks</a></li>';
                detail += '<li role=\'presentation\'><a href=\'#' + shortName + '_high\' aria-controls=\'high scores\' role=\'tab\' data-toggle=\'tab\'>High Ranks</a></li>';
                detail += '</ul><div class=\'tab-content\'>';
                detail += '<div id=\'' + shortName + '_low\' class=\'tab-pane active\'>';
                detail += '<ul class=\'columns\'>';
                for (var j = 0; j < lowNames.length; j++) {
                    detail += '<li class=\'list-unstyled\'><a href=\'#user/' + encodeURIComponent(lowNames[j]) + '\'>' + lowNames[j] + '</a></li>';

                }
                detail += '</ul></div>';
                detail += '<div id=\'' + shortName + '_med\' class=\'tab-pane\' >';
                detail += '<ul class=\'columns\'>';
                for (var j = 0; j < medNames.length; j++) {
                    detail += '<li class=\'list-unstyled\'><a href=\'#user/' + encodeURIComponent(medNames[j]) + '\'>' + medNames[j] + '</a></li>';

                }
                detail += '</ul></div>';

                detail += '<div id=\'' + shortName + '_high\' class=\'tab-pane\'>';
                detail += '<ul class=\'columns\'>';
                for (var j = 0; j < highNames.length; j++) {
                    detail += '<li class=\'list-unstyled\'><a href=\'#user/' + encodeURIComponent(highNames[j]) + '\'>' + highNames[j] + '</a></li>';

                }
                detail += '</ul></div>';
                detail += '</div></div>';


                /* Accessibility fix: make category links keyboard accessible */

                html += '<div id=\'instructor_results_category_' + shortName + '\' class=\'row class_summary_row\' aria-expanded=\'false\'>';
                html += '<div class=\'col-md-4 text-right-md\'><a href=\'javascript:void(0);\' class=\'topic_link\' onclick=\'player.toggle_instructor_results_details("' + shortName + '");\'>' + longName + '</a></div>';
                html += '<div class=\'col-md-8\'><div class=\'progress\'>';

                /* Accessibility fix: we are removing the aria attributes and using just the html
                   to represent the score */

                //html += "<div class='progress-bar progress-bar-danger' role='progressbar' aria-valuenow='" + displaylowPercentage + "' aria-valuemin='0' aria-valuemax='100' style=' width:" + lowPercentage + "%'><span class='bar_text'>" + displaylowPercentage + "</span><div class='danger_color'></div></div>";

                html += '<div class=\'progress-bar progress-bar-danger\' style=\' width:' + lowPercentage + '%\'><span class=\'bar_text\'>' + displaylowPercentage + '</span><div class=\'danger_color\'><span class=\'visually-hidden\'>Low</span></div></div>';

                //html += "<div class='progress-bar progress-bar-warning' role='progressbar' aria-valuenow='" + displaymidPercentage + "' aria-valuemin='0' aria-valuemax='100' style=' width:" + midPercentage + "%'><span class='bar_text'>" + displaymidPercentage + "</span><div class='warning_color'></div></div>";

                html += '<div class=\'progress-bar progress-bar-warning\' style=\' width:' + midPercentage + '%\'><span class=\'bar_text\'>' + displaymidPercentage + '</span><div class=\'warning_color\'><span class=\'visually-hidden\'>Moderate</span></div></div>';

                //html += "<div class='progress-bar progress-bar-success' role='progressbar' aria-valuenow='" + displayhighPercentage + "' aria-valuemin='0' aria-valuemax='100' style=' width:" + highPercentage + "%'><span class='bar_text'>" + displayhighPercentage + "</span><div class='success_color'></div></div>";

                html += '<div class=\'progress-bar progress-bar-success\' style=\' width:' + highPercentage + '%\'><span class=\'bar_text\'>' + displayhighPercentage + '</span><div class=\'success_color\'><span class=\'visually-hidden\'>High</span></div></div>';


                html += '</div></div>';
                html += '<div style=\'clear:both;\'></div>';
                html += '<div class=\'row results_details\' id=\'instructor_results_details_' + shortName + '\' aria-hidden=\'true\'>';
                html += '<div class=\'col-md-4\'></div><div class=\'col-md-8 student_results_details\'>';
                html += detail;
                html += '</div>';
                html += '</div>';


                html += '</div>';


                row.html = html;
                rowCollection.push(row);



            }



        } else {

            //if (player.current_student_for_report === "Entire class") {
            //    player.current_student_for_report = "all";
            //}

            var curr_student = player.current_student_for_report;
            if (curr_student === 'Entire class' || curr_student === 'entire class') {
                curr_student = 'all';
            }

            //safe_log("curr_student: " + curr_student);

            //var data = player.class_data[player.current_student_for_report];
            var data = player.class_data[curr_student];

            if (data === undefined) {
                //safe_log("data is undefined, returning");
                return;
            }

            $(container_element).empty();

            for (var i = 0; i < player.measure_names.length; i++) {
                var html = '';
                var row = {};

                var shortName = player.measure_names[i].key;
                var longName = player.measure_names[i].value;


                row.shortName = shortName;
                row.longName = longName;

                row.score = data.scores[shortName];
                var color = '';
                var style = '';

                var range_text = '';

                if (row.score <= 25) {
                    style = 'progress-bar-danger';
                    color = 'danger_color';
                    range_text = 'Low';
                } else if (row.score <= 75) {
                    style = 'progress-bar-warning';
                    color = 'warning_color';
                    range_text = 'Moderate';
                } else {
                    style = 'progress-bar-success';
                    color = 'success_color';
                    range_text = 'High';
                }


                html += '<div class=\'row class_summary_row\'>';
                html += '<div class=\'col-md-4 text-right-md\'><span>' + longName + '</span></div>';
                html += '<div class=\'col-md-8\'><div class=\'progress\'>';

                /* Accessibility fix: we are removing the aria attributes and using just the html
                   to represent the score */

                //html += "<div class='progress-bar " + style + "' role='progressbar' aria-valuenow='" + row.score + "' aria-valuemin='0' aria-valuemax='100' style='min-width:2em; width:" + row.score + "%'><span class='bar_text'>" + row.score + "%</span><div class='" + color + "'></div></div><div class='gray_color'></div>";

                html += '<div class=\'progress-bar ' + style + '\'  style=\'min-width:2em; width:' + row.score + '%\'><span class=\'bar_text\'>' + row.score + '%</span><div class=\'' + color + '\'><span class=\'visually-hidden\'>' + range_text + '</span></div></div><div class=\'gray_color\'></div>';



                html += '</div></div>';

                html += '<div class=\'row results_details\' id=\'instructor_results_details_' + shortName + '\'>';
                html += '<div class=\'col-md-4\'></div><div class=\'col-md-8 student_results_details\'>';

                html += '</div>';
                html += '</div>';


                html += '</div>';

                row.html = html;
                row.lowPercentage = row.score;
                row.highPercentage = row.score;
                rowCollection.push(row);



            }

        }
        var sort_function = function(a, b) {
            if (a.shortName * 1 > b.shortName * 1) {
                return 1;
            }
            if (a.shortName * 1 < b.shortName * 1) {
                return -1;
            }
            return 0;
        };

        //safe_log("player.class_results_sort_order = " + player.class_results_sort_order);
        //safe_log(player.current_student_for_report);

        if (player.class_results_sort_order === 'lowest') {
            sort_function = function(a, b) {
                // Using a different sort method for "Entire class"
                if (player.current_student_for_report === 'all') {
                    //return (b.lowPercentage - a.lowPercentage);
                    return ((b.lowPercentage * 100000 + b.midPercentage * 100 + b.highPercentage) - (a.lowPercentage * 100000 + a.midPercentage * 100 + a.highPercentage));
                }
                return (a.lowPercentage - b.lowPercentage);
            };
        }


        if (player.class_results_sort_order === 'highest') {
            sort_function = function(a, b) {
                if (player.current_student_for_report === 'all') {
                    return ((b.highPercentage * 100000 + b.midPercentage * 100 + b.lowPercentage) - (a.highPercentage * 100000 + a.midPercentage * 100 + b.lowPercentage));
                }
                return (b.highPercentage - a.highPercentage);
            };
        }

        rowCollection.sort(sort_function);


        var h = '';
        for (var i = 0; i < rowCollection.length; i++) {
            var row = rowCollection[i];
            h = h + row.html;

        }



        $(container_element).append(h);
        //now initialize the tabs
        $('[role=tab]').click(function(e) {
            e.preventDefault();
            e.stopPropagation();
            $(this).tab('show');

        });


    },

    get_section_by_title: function(title) {


        for (var i = 0; i < player.sections.length; i++) {
            if (player.sections[i].title == title) {
                return player.sections[i];
            }

        }
    },

    show_feedback_for_instructor: function() {

        var source = $('[data-block_type=results_details_text]').find('iframe').contents().find('body').html();

        source = source.replace(/<h4/g, '<h3');
        source = source.replace(/<\/h4>/g, '</h3>');

        $('[data-block_type=\'instructor_feedback_list\']').html(source);
        $('[data-block_type=\'instructor_feedback_list\']').find('.results_info').removeAttr('id');
        $('[data-block_type=\'instructor_feedback_list\']').find('.low_category_info, .mid_category_info, .high_category_info').show().addClass('review_category_box');
        $('[data-block_type=\'instructor_feedback_list\']').find('.low_category_info').prepend('<h4>Low Ranks</h4>');
        $('[data-block_type=\'instructor_feedback_list\']').find('.mid_category_info').prepend('<h4>Moderate Ranks</h4>');
        $('[data-block_type=\'instructor_feedback_list\']').find('.high_category_info').prepend('<h4>High Ranks</h4>');
        var s = player.get_section_by_title('List of Feedback');
        player.show_section(s.index);
    },

    show_question_list: function() {


        $('[data-block_type=question_list]').empty();

        var listHtml = '<div class=\'list-group\'>';

        for (var i = 0; i < player.activity.queries.length; i++) {
            var shortName = player.activity.queries[i].md.measure;

            if (typeof shortName != 'undefined') {
                var isReversed = player.activity.queries[i].md.reverse_score == 'true';
                var longName = '';
                for (var j = 0; j < player.measure_names.length; j++) {
                    if (player.measure_names[j].key == shortName) {
                        longName = player.measure_names[j].value;
                    }
                }

                listHtml += '<div class=\'list-group-item\'>';
                listHtml += '<div><p>' + player.activity.queries[i].query_text + '</p></div>';
                listHtml += '<div><span class=\'label label-default\'>' + longName + '</span>';
                if (isReversed) {
                    listHtml += ' <span class=\'label label-warning\'>Reverse Score</span>';
                }
                listHtml += '</div>';


                listHtml += '</div>';
            }
        }


        var s = player.get_section_by_title('Inventory Questions');
        var target = s.jq.find('[data-block_type=question_list]');

        target.append(listHtml);
        player.show_section(s.index);
    },

    // "Your Results" page
    generate_student_report: function(container_element) {

        //safe_log("generate_student_report");
        var source;
        if (useLegacyScales) {
            source = $('[data-block_type=results_details_text]').find('iframe').contents();
        }
        else {
            source = $('[data-block_type=results_details_text_new]').find('iframe').contents();
        }

        $(container_element).empty();

        var measure_names = useLegacyScales ? player.measure_names : player.measure_names_new;
        var table = useLegacyScales ? player.table : player.table_new;

        for (var i = 0; i < measure_names.length; i++) {

            // brb: don't include any measure names if key >= 90
            if (Number(measure_names[i].key) >= 90) {
                continue;
            }

            var rowHTML = '';
            var shortName = measure_names[i].key;
            var longName = measure_names[i].value;
            var rawscore = measure_names[i].score;
            var score = table[shortName][rawscore];


            var measure_source = source.find('#results_info_' + shortName);

            //convert score into percentile

            //score = score * 10;
            var quartile_category = 'in the lowest 25% of the national sample';
            var infoClass = '.low_category_info';
            var barColorStyle = 'progress-bar-danger';
            var color = 'danger_color';

            /* Accessibility fix: we are removing the aria attributes and using just the html
               to represent the score */

            var range_text = 'Low';

            if (score > 25) {
                barColorStyle = 'progress-bar-warning';
                quartile_category = 'in the middle 50% of the national sample';
                infoClass = '.mid_category_info';
                color = 'warning_color';
                range_text = 'Moderate';
            }
            if (score > 75) {
                barColorStyle = 'progress-bar-success';
                quartile_category = 'in the highest 25% of the national sample';
                infoClass = '.high_category_info';
                color = 'success_color';
                range_text = 'High';
            }
            //add to display

            /* Accessibility fix: The categories need to be made keyboard accessible */

            rowHTML += '<div id=\'results_category_' + shortName + '\' class=\'row results_row\' onclick=\'player.toggle_results_details("' + shortName + '");\' aria-expanded=\'false\'>';

            //rowHTML += "<div class='col-md-4 text-right-md result_label'><span>" + longName + "</span></div>";

            rowHTML += '<h3 class=\'scale_name\'><a href=\'javascript:void(0);\' class=\'col-md-4 text-right-md result_label\' aria-expanded=\'false\'><span class=\'visually-hidden\'>Scale name:</span> ' + longName + '</a></h3>';

            //rowHTML += "<div class='col-md-8'><div class='progress'><div class=' progress-bar progress-bar " + barColorStyle + " role='progressbar' aria-valuenow='" + score + "' aria-valuemin='0' aria-valuemax='100' style='min-width:2em; width:" + score + "%'><span class='bar_text'>" + score + "%</span><div class='" + color + "'></div></div><div class='gray_color'></div></div></div>";

            rowHTML += '<div class=\'col-md-8\'><div class=\'progress\'><div class=\' progress-bar progress-bar ' + barColorStyle + '\' style=\'min-width:2em; width:' + score + '%\'><span class=\'bar_text\'>' + score + '% <span class=\'visually-hidden\'>' + range_text + '</span></span><div class=\'' + color + '\'></div></div><div class=\'gray_color\'></div></div></div>';

            rowHTML += '</div>';

            rowHTML += '<div class=\'row results_details\' id=\'results_details_' + shortName + '\' aria-hidden=\'true\'>';
            rowHTML += '<div class=\'col-md-4\'></div><div class=\'col-md-8 student_results_details\'>';
            rowHTML += measure_source.html();
            rowHTML += '</div>';
            rowHTML += '</div>';

            $(container_element).append(rowHTML);

            $('#results_details_' + shortName).find('.percentile_score').html(score + '%');
            $('#results_details_' + shortName).find('.quartile_category').html('(' + quartile_category + ')');

            /* Accessibility fix: Remove unused categories from HTML. */

            var $this_results_details = $('#results_details_' + shortName);

            $this_results_details.find('.low_category_info, .mid_category_info, .high_category_info').each(function() {
                $this = $(this);
                var item_class = $this.attr('class');
                if (('.' + item_class) === infoClass) {
                    $this.addClass('active').show();
                } else {
                    $this.remove();
                }
            });
        }

    },
    update_section_status: function() {
        this._super();
        player.update_progress_bar();
    },
    restore_section: function() {

        // this should only be called if ARGA is initialized

        var lvs = Get_ARGA_Data('LVSX');

        var las = Get_ARGA_Data('LASX');

        //safe_log('restore_section: LVSX = ' + lvs);
        //safe_log('restore_section: LASX = ' + las);

        // if we have a previously-stored LVS, show it now

        //safe_log('restore_section: isInstructor = ' + player.isInstructor);

        if (lvs != '' && las != '') {

            // some students have their LVSX set to 12 instead of 11
            // (for reasons unknown at this point) so we need to check
            // for this and force them back to 11
            if (!player.isInstructor && lvs > 11) {

                //safe_log('restore_section: LVSX for student is too high (' + lvs + '), setting to 11');
                lvs = 11;
                las = 12;
            }

            //safe_log('restore_section: setting last_available_section to ' + (las * 1));

            this.last_available_section = las * 1;

            //safe_log('restore_section: calling show_section(' + (lvs * 1) + ')');
            this.show_section(lvs * 1);



            // otherwise show section 0

        } else {

            // first set LVS now so that we *don't* save ARGA in update_section_status --

            // there's no need to do so since nothing's happened yet

            Set_ARGA_Data('LVSX', '0');

            this.show_section(0);

        }

    },


    show_section: function(section_to_show) {

        //window.alert(section_to_show);
        var direction = 'right';
        if (section_to_show == 'previous') {
            section_to_show = this.section_currently_showing - 1;
            direction = 'left';
        } else if (section_to_show == 'next') {
            section_to_show = this.section_currently_showing + 1;
        }

        if (section_to_show == null || isNaN(section_to_show) || section_to_show < 0 || section_to_show >= this.sections.length) {
            return;
        }

        // if user has to view sections in sequence and hasn't gotten up to this one, don't allow it


        if (this.md.sequenced_sections == 'true' && section_to_show > this.last_available_section && !player.isDebug) {
            // but let instructors through
            if (player.isInstructor) {
                // Standard_Dialog.alert("Please note: Students need to read and complete each section of the activity before moving on to the next section.  Instructors, however, can skip around between sections as they choose.");
            } else {
                Standard_Dialog.open(this.md.section_sequence_message);
                return;
            }
        }


        this.show_section_animate(section_to_show, direction);

        // process iframes for the section, unless all were preloaded
        if (player.md.preload_all_iframes != 'true') {
            this.figures.process_iframes(this.get_current_section().jq); // iframes
        }

        this.update_section_status();
        this.update_navigation();

        //safe_log(player.get_current_section());

        //safe_log(player.get_current_section().all_questions_answered);

        //if there are questions in this section, hide the next button

        //safe_log(player.get_current_section().all_questions_answered);
        if (!player.get_current_section().all_questions_answered) {
            $('#next_button').hide();
            $('#next_button').attr('aria-hidden', 'true');
        } else {
            $('#next_button').show();
            $('#next_button').attr('aria-hidden', 'false');
        }

        if (player.get_current_section().index - 1 == player.sections.length) {
            $('#next_button').hide();
            $('#next_button').attr('aria-hidden', 'true');
        }


        if (player.get_current_section_jq().find('[data-block_type=\'individual_student_results\']').length > 0) {
            if (!player.isInstructor) {

                //show results
                player.generate_student_report(player.get_current_section_jq().find('[data-block_type=\'individual_student_results\']')[0]);
                $('#next_button').hide();
                $('#next_button').attr('aria-hidden', 'true');
            }
        }

        if (player.get_current_section_jq().find('[data-block_type=\'class_results_summary\']').length > 0) {
            if (player.isInstructor) {
                player.generate_instructor_report(player.get_current_section_jq().find('[data-block_type=\'class_results_summary\']')[0]);

            }
        }


        if (!player.isInstructor && player.get_current_section_jq().attr('data-block_type') == 'survey_page') {
            $('.student_progress_bar_container').show();
        } else {
            $('.student_progress_bar_container').hide();
        }


        if (player.get_current_section().index + 1 == player.sections.length) {
            $('#next_button').hide();
            $('#next_button').attr('aria-hidden', 'true');

            this.update_progress_bar();
        }

        /* Bruce: I'll fix vertical scrolling so that this message isn't needed */
        /*
        if (player.get_current_section_jq().find(".question_submit_button").length > 0){
            $("#scroll_message").show();
        }else{
            $("#scroll_message").hide();
        }
        */

        /* Accessibility fix: Focus headers on page loads */
        var sec_id = 'digfir_section_' + player.get_current_section().index;
        //safe_log("sec_id = " + sec_id);
        var $sec_div = $('#' + sec_id);
        //var sec_block_type = $sec_div.attr('data-block_type');
        //if (sec_block_type !== undefined &&
        //   (sec_block_type === "survey_page" || sec_block_type === "demo_page")) {

        if (sec_id === 'digfir_section_0' || sec_id === 'digfir_section_16') {
            //safe_log("focus h1");

            $('span.ui-helper-hidden-accessible').remove();
            $('h2').focus();
        } else {
            //safe_log("focus h2");

            // This hidden span had role="status" and was causing "status" to be read
            // instead of the h2 text when a page loaded in Android Talk Back
            $('span.ui-helper-hidden-accessible').remove();
            $sec_div.find('h2.section-title').focus();
        }

        // if this is the instructor and we are on the report page
        // then hide the next button.
        if (player.isInstructor && player.section_currently_showing === 11) {
            $('#next_button').hide();
            $('#next_button').attr('aria-hidden', 'true');
        }

    },
    show_section_animate: function(section_to_show, direction) {
        this._super(section_to_show, direction);

        var curr_id = 'digfir_section_' + section_to_show;

        $('[data-type="section"]').each(function() {
            var $this = $(this);
            var id = $this.attr('id');

            if (id === curr_id) {
                $this.attr('aria-hidden', 'false');
            } else {
                $this.attr('aria-hidden', 'true');
            }

        });


        //safe_log("show_section_animate: " + section_to_show);

        // brb: for testing purposes
        if (section_to_show > 0 && section_to_show < 11) {
            if (!player.ACTIVITY_COMPLETED) {
                // brb: checkboxes to trigger intentional fail on DS save
                /*
                $("#initial_ds_fail_cb").remove();
                $("#retry_ds_fail_cb").remove();

                $("#question_action_div_" + section_to_show).before("<p id='initial_ds_fail_cb'><input type='checkbox' id='initial_ds_fail' value='1'> <label for='initial_ds_fail'>FAIL on initial save to DS</label></p><p id='retry_ds_fail_cb'><input type='checkbox' id='retry_ds_fail' value='1'> <label for='retry_ds_fail'>FAIL on retry save to DS (the above check box must be checked as well)</label></p>");
                */
            } // end if

            /*
            if ($("#check_save").length == 0) {
                $("#manuscript").prepend("<p><button id='check_save'>Check DNS</button></p>");
            }
            */
        } // end if

        if (section_to_show == 11) {

            /*
            if ($("#save_ds_info").length == 0) {
                $("#manuscript").prepend("<p><button id='save_ds_info'>Save DS Info</button></p>");
            }

            if ($("#calculate_scores").length == 0) {
                $("#manuscript").prepend("<p><button id='calculate_scores'>Calculate scores</button> Limit to measure <input type='text' id='measure_limit' size='2' maxlength='2'/></p>");
            }
            */
        }

        //if there are questions in this section, hide the next button

        //safe_log(player.get_current_section().all_questions_answered);



        if (player.get_current_section_jq().find('[data-block_type=\'individual_student_results\']').length > 0) {
            if (!player.isInstructor) {

                //show results
                player.generate_student_report(player.get_current_section_jq().find('[data-block_type=\'individual_student_results\']')[0]);
            }
        }

        if (player.get_current_section_jq().find('[data-block_type=\'class_results_summary\']').length > 0) {
            if (player.isInstructor) {
                player.generate_instructor_report(player.get_current_section_jq().find('[data-block_type=\'class_results_summary\']')[0]);

            }
        }


        if (!player.isInstructor && player.get_current_section_jq().attr('data-block_type') == 'survey_page') {
            $('.student_progress_bar_container').show();
        } else {
            $('.student_progress_bar_container').hide();
        }


        // scroll to top
        window.scrollTo(0, 0);

        if (xBookUtils.inPX()) {
            //safe_log("scrolling window to top");
            player.scrolling_window_jq.scrollTop(0);
        }


    },
    show_student_help: function() {
        $('#student_help_modal').modal('show');
    },
    show_navigation: function() {
        /*
                var html = "<div class='navbar navbar-inverse navbar-fixed-top'>";
                html += "<div class='container'>";
                html += "<div class='navbar-header'>"
                html += "<button type='button' id='navbar_toggle_button' class='navbar-toggle collapsed' data-toggle='collapse' data-target='navbar' aria-expanded='false' aria-controls='navbar'>";
                html += "<span class='sr-only'>Toggle navigation</span>";
                html += "<span class='icon-bar'></span>";
                html += "<span class='icon-bar'></span>";
                html += "<span class='icon-bar'></span>";
                html += "</button>";
                html += "<a class='navbar-brand' href='#'>CCSI survey</a>";
                html += "</div>";
                html += "<div id='navbar' class='collapse navbar-collapse'>";
                html += "<ul class='nav navbar-nav'>";
                html += "<li class='active'><a href='#'>Home</a></li>";
                html += "<li><a href='#' onClick='player.make_fake_data();'>Make Fake Demo Data</a></li>";
                html += "<li class='instructor_nav'><a href='#' onclick='player.show_question_list();'>View Survey Questions</a>";
                html += "</ul>";
                html += "</div>";
                html += "</div>";
                html += "</div>";

                */
        var html = '';

        /* Accessibility fix: We only need to add the help button for students */
        /* We need to move this to initialize2, after isInstructor has been set */
        
        	if (!player.isInstructor) {
        	    html+="<div class='help_nav'>";
                    html+="<button aria-label='Help' id='student_help_button' class='btn btn-sm btn-info' type='button' onclick='player.show_student_help();'><span class='glyphicon glyphicon-question-sign'></span> Help</button>"
                    html+="</div>";
        	}
    

        /* Accessibility fix: Hide progress bar from screen readers.  We are using the <h2>
           to inicate the page of questions we are on.  The progress bar is for aesthetics
           only. */

        html += '<div class=\'container\' aria-hidden=\'true\'>';
        html += '<div class=\'student_progress_bar_container\'>';
        html += '<div style=\'float:left;padding-right:8px;\'><p class=\'h3\'>ACES Inventory</p></div>';
        html += '<div style=\'float:left;padding-top:8px;\'>';

        $('[data-block_type=survey_page]').each(function(index, element) {
            var section_index = $(element).attr('data-section-index');
            html += '<div class=\'student_progress_box\' id=\'student_progress_box_' + section_index + '\'></div>';


        });

        html += '</div><div style=\'clear:both;\'></div></div></div>';



        /*

                 + "<td>"+ UI_Elements.get_button_html({
                     id: "previous_button",
                     extra_class: "toolbar_button prev_next_buttons",
                     label: "Previous",
                     fn: 'player.show_section("previous")'
                 }) + "</td>"


                 + "<td>"+ UI_Elements.get_button_html({
                     id: "slide_number",
                     extra_class: "toolbar_button",
                     label: "1 of " + this.sections.length,
                     fn: 'player.show_toc()'
                 }) + "</td>"

                 + "<td>"+ UI_Elements.get_button_html({
                     id: "next_button",
                     extra_class: "toolbar_button prev_next_buttons",
                     label: "Next",
                     fn: 'player.show_section("next")'


 */


        $('[data-type=chapter]').before(html);

        // button at the bottom of the manuscript to go on to the next step

        // only add the Next button if the due date hasn't passed
        if (!due_date_has_passed()) {
            var next_button_html = '<button aria-label=\'Next\' type=\'button\' id=\'next_button\' class=\'btn btn-lg btn-primary\' onclick=\'player.show_section("next");\'>Next</button>';
            $('[data-type=chapter]').append(next_button_html);
        }
        $('#navbar').collapse({
            toggle: false
        });


        $('#navbar_toggle_button').click(function() {
            $('#navbar').collapse('toggle');

        });
        //$("#student_help_modal").modal();

        //move the modal to the root so it doesnt get hidden
        $('#student_help_modal').appendTo('#manuscript');
        $('#student_help_modal2').appendTo('#manuscript');


        /* Bruce: removing the scroll message.  I'll fix the vertical scrolling so it starts
           at the top of the page */
        //        $("[data-type=chapter]").append("<div id='scroll_message'><p>Each time you click the Submit button, please scroll up to the top of the next page.</p></div>")


    },

    make_fake_data: function() {
        player.generate_fake_class_data();
        for (var i = 0; i < player.measure_names.length; i++) {


            player.measure_names[i].score = Math.floor(Math.random() * 60) + 40;

        }

        //go to results, assume the last section



    },
    generate_fake_class_data: function() {

        for (var s = 0; s < 10; s++) {
            for (var i = 0; i < player.measure_names.length; i++) {
                var student = {};
                student.name = 'Last, First' + s;
                student.scores = {};
                student.demographics = {};
                for (var j = 0; j < player.measure_names.length; j++) {


                    student.scores[player.measure_names[j].key] = Math.floor(Math.random() * 100);

                }

                for (var k = 0; k < player.demographic_keys.length; k++) {
                    student.demographics[player.demographic_keys[k]] = 'abc123';
                }

                player.class_data[student.name] = student;


            }

        }



    },
    html_to_print: '',
    print_header: '',
    isDebug: false,

    print_element: function(selector, headerText) {
        var element = $(selector);
        player.print_header = headerText;
        player.html_to_print = element.html();
        var win = window.open('asset/print_page.html', 'printwindow');



        //win.document.write(html);



    },
    update_navigation: function() {
        // show/hide the "next" button as appropriate
        if (this.last_available_section > this.section_currently_showing && this.showing_last_section() == false) {
            UI_Elements.toggle_button('step_button', true);
        } else {
            UI_Elements.toggle_button('step_button', false);
        }

        if (this.showing_last_section() && player.activity.answered_all_queries) {
            player.show_completion_message();
        }
    },
    show_instructor_home: function() {

        var s = player.get_section_by_title('Instructor Home');
        player.show_section(s.index);
    },

    show_instructor_class_report: function() {
        var s = player.get_section_by_title('Class Report');
        player.show_section(s.index);

    },

    show_instructor_roster_report: function() {
        var s = player.get_section_by_title('Roster Report');
        player.show_section(s.index);

    },
    dontIncludeData: false,

    initialize: function(id, panel) {
        // this._super();
        //safe_log("player.initialize: 1106");

        /*
        if (player.ARGA_running) {
            try {
                var dejs_arr = ARGA_API.dejs_data;
                for (var i=0; i<dejs_arr.length; i++) {
                    if (dejs_arr[i].name === "cmi.completion_status") {
                        this.ACTIVITY_COMPLETED = (ARGA_API.dejs_data[i].value == "completed");
                        safe_log("ACTIVITY_COMPLETED = " + this.ACTIVITY_COMPLETED);
                        break;
                    }
                }
            }
            catch(err) {
                safe_log("initialize2: Can't get cmi.completion_status: " + err)
            }
        }
        */

        this.manuscript_id = id;
        //this.initial_displayed_panel = 0;

        if (typeof panel !== 'undefined') {
            //initial_section_index = panel;
            //window.alert(this.initial_displayed_panel);
        }

        // extract metadata (this might be already done by the activity-specific
        // player, but that's OK; we'll just re-do it here, which is no problem.)
        this.extract_activity_metadata();

        // have to do variables first because that replaces the body html
        this.variables = new Variables();
        this.figures = new Figures();
        this.xrefs = new XRefs();
        this.idxrefs = new IdXRefs();
        this.links = new Links();
        this.activity = new Activity();
        this.interactions = new Interactions();
        this.tables = new Tables();
        this.glossary = new Glossary();

        // Prepare for activity functionality by getting ARGA data;
        // that fn will call Initialize_ARGA_Session_Callback (see below)
        var success = false;
        if (window.Initialize_ARGA_Session != null) {
            success = Initialize_ARGA_Session({
                'fail_silently': (this.md.ARGA_fail_silently != 'false'),
                'retrieve_class_data': 1,
                'retrieve_class_data_rights': '3_instructor',
                'cancel_initialization_alert': true
            });
        }
        if (!success) {
            this.ARGA_running = false;
            //safe_log("running in non-ARGA mode");

            // We need to initialize the player after a timeout (mimicking what would happen
            // if ARGA was initialized and initialize2 was called on a callback) so that
            // inherited players will be called in the proper order.
            setTimeout('player.initialize2()', 1);
        } else {
            this.ARGA_running = true;
        }



        this.generate_instructor_report_data();

        // hide section numbers and titles
        $('h2').hide();

        // also get rid of chapter numbers in question numbers
        $('[data-type=question]').find('h3').each(function(index, element) {
            var html = $(this).html();
            //html = html.replace(/^Question/, "");
            html = html.replace(/\d+\.(\d+)/, '$1.');
            $(this).html(html);
        });

        // activity title is data-type="title" inside h1
        this.activity_title = $('h1').find('[data-type=title]').html();

        // extract thumbnail
        var jq = $('[data-block_type="thumbnail"]');
        this.activity_thumbnail_src = jq.find('img').attr('src');
        jq.hide();

        // assign classes to chapter
        $('[data-type=\'chapter\']').addClass('ui-widget-content').addClass('ui-corner-all');


        this.activity = new Activity_gore();



        window.location.hash = '';

        // Need to move this to initialize2 after isInstructor is set
        /*
        player.ds.initialize(function(){
            console.log("data services initialized");
            //show individual report
            player.get_user_data_from_ARGA();
            player.get_class_data_from_ARGA();
            if (player.isInstructor) {
		player.generate_instructor_report_data();
            }

	    player.generate_student_report($("[data-block_type='individual_student_results']")[0]);
        });
	*/

        //event handlers for results page controls that are added via rawhtml
        $('#class_data_sort_order').change(function() {
            player.class_results_sort_order = $('#class_data_sort_order').val();
            player.generate_instructor_report();

        });

        $('#roster_data_sort_order').change(function() {
            player.roster_results_sort_order = $('#roster_data_sort_order').val();
            player.generate_instructor_roster_report();


        });


        $('#class_data_topic_dropdown').change(function() {
            player.current_topic = $('#class_data_topic_dropdown').val();
            player.generate_instructor_roster_report();

        });



        // handler for class report student drop down list
        // Adding this to the autocomplete function call
        //$("#class_data_student_dropdown").change(function(){

        // Listen from return key in dropdown
        $('#class_data_student_dropdown').keydown(function(event) {

            // we only want to handle Enter key
            if (event.keyCode != 13) {
                return;
            }

            $('#class_data_student_dropdown').autocomplete('close');

            var student = $('#class_data_student_dropdown').val();
            if (student === 'entire class') {
                student = 'Entire class';
            }
            var student_exists = false;
            var arr_count = player.autocompleteArray.length;
            for (var i = 0; i < arr_count; i++) {
                if (player.autocompleteArray[i] === student) {
                    student_exists = true;
                    break;
                }
            }

            if (student_exists) {
                routie('user/' + encodeURIComponent($('#class_data_student_dropdown').val()));
            } else {
                //safe_log("Can't find " + student + " in autocompleteArray (3)");
                alert('Can\'t find student ' + student + ' in class report');
            }
        });

        $('#do_not_include_check').click(function() {
            player.dontIncludeData = $('#do_not_include_check')[0].checked;
            if (player.ARGA_running) {
                Set_ARGA_Data('dontIncludeData', player.dontIncludeData);
                Save_ARGA_Data();
            }


        });

        // Legacy scales checkbox
        $('#legacy').change(function () {
            if ($(this).is(':checked')) {
                useLegacyScales = true;
            }
            else {
                useLegacyScales = false;
            }
            player.generate_student_report(player.get_current_section_jq().find('[data-block_type=\'individual_student_results\']')[0]);
        });

        this.scrolling_window_jq = $(window);

        try {
            this.fne_jq = $('#fne-content', window.parent.document);
            if (this.fne_jq.length == 0) {
                this.fne_jq = null;
            } else {
                this.scrolling_window_jq = this.fne_jq;
            }
        } catch (e) {}


        // Accessibility fix: Add 'main' role to section div
        $('[data-type="section"]').each(function() {
            $(this).attr('role', 'main');
        });


    },
    initialize2: function() {

        //safe_log("player.initialize2");

        if (player.ARGA_running) {
            try {
                var dejs_arr = ARGA_API.dejs_data;
                for (var i = 0; i < dejs_arr.length; i++) {
                    if (dejs_arr[i].name === 'cmi.completion_status') {
                        this.ACTIVITY_COMPLETED = (ARGA_API.dejs_data[i].value == 'completed');
                        //safe_log("ACTIVITY_COMPLETED = " + this.ACTIVITY_COMPLETED);
                        break;
                    }
                }
            } catch (err) {
                safe_log('initialize2: Can\'t get cmi.completion_status: ' + err);
            }


            this.px_student_name = parent.PxPage.Context.User.CurrentUserFormattedName;
            this.px_instructor_name = parent.PxPage.Context.Course.InstructorName;
            this.px_term = parent.PxPage.Context.Course.AcademicTerm;
            //this.px_assessment_date = parent.PxPage.Context.Course;
        }

        //safe_log("table data");
        //safe_log(player.table);

        var link_handler = new LinkHandler();

        var $h1 = $('h1.section-title');
        $h1.text('ACES Inventory');
        $h1.addClass('visually-hidden');


        $('#student_help_modal').on('hidden.bs.modal', function() {
            $('#student_help_button').focus();
        });
        /*
        $('#student_help_modal').on('shown.bs.modal', function () {
            $('#aces_help_what_is_aces').focus()
        })
        */


        //createAutoComplete();

        /* Accessibility fix for drop down birth year question */
        /* This is a complete hack but I don't have time to rewrite the drop
           down functionality to support this one question */
        var $birth_year_div = $('#birth_year_question');
        var birth_year_html = $birth_year_div.html();
        birth_year_html = birth_year_html.replace('What is your birth year?', '<label for=\'query_answer_96\'>What is your birth year?</label>');
        $birth_year_div.html(birth_year_html);

        // We can remove all <h3> tags for questions since we don't use them
        //$('[data-type="question"] > h3').remove();
        //$('[data-type="question"] > h3').addClass('visually-hidden');

        $('[data-block_type="survey_question"]').each(function() {
            var $this = $(this);
            var number = $this.attr('data-number');
            if (number !== undefined) {
                $this.prepend('<h3 class="question_number">Question ' + number + '</h3>');
            }
        });



        /* Accessibility fix: set focus on question pages */
        $('h2.section-title').each(function() {
            var $this = $(this);
            $this.attr('tabindex', '-1'); //.css('outline', 'none');
        });
        $('h1').attr('tabindex', '-1').css('outline', 'none');


        $('wbr').each(function() {
            $(this).attr('aria-hidden', 'true');
        });


        //safe_log("PXPage");
        //safe_log(parent.PxPage);

        //initialize routie routes

        routie({



            'topic/:topic': function(topic) {
                player.current_topic = $('#class_data_topic_dropdown').val();
                player.generate_instructor_roster_report();



                player.show_instructor_roster_report();
            },

            'user/:user': function(user) {
                player.current_student_for_report = decodeURIComponent(user);

                //safe_log("user/:user, current_student_for_report = " + player.current_student_for_report);

                $('#class_data_student_dropdown').val(player.current_student_for_report);

                //$("#class_data_student_dropdown").select2("val", player.current_student_for_report);
                player.generate_instructor_report();
                player.show_instructor_class_report();

            },
            'home': function() {

                player.show_instructor_home();
            },
            'quizHome': function() {

                player.show_section(0);
            }

        });



        $('.class_data_export').click(function() {
            player.export_class_csv();
            return false;
        });


        $('.demographic_data_export').click(function() {
            player.export_class_demographics_csv();
            return false;
        });

        if (getParameterByName('debug') == 'true') {
            player.make_fake_data();
            player.isDebug = true;
        }

        player.isInstructor = false;
        if (player.ARGA_running) {
            if (Get_ARGA_Data('user_rights') == '3_instructor') {
                player.isInstructor = true;
            }
        } else {
            player.isInstructor = (getParameterByName('isInstructor') == 'true');
        }
        //safe_log('initialize2: isInstructor = ' + player.isInstructor);

        // brb: if this is a student then deactivate the instructor buttons
        if (!player.isInstructor) {
            $('.instructor_button').remove();
            $('[data-block_type="instructor_page"]').html('<p></p>');
        }


        /* Moved here from initialize because we need isInstructor to be set */
        player.ds.initialize(function() {

            // this function is the callback for ds.initialize and will
            // only be executed if ds.initialize is successful

            //safe_log("data services initialized");
            //safe_log("ACTIVITY_COMPLETED = " + player.ACTIVITY_COMPLETED);

            //show individual report
            player.get_user_data_from_ARGA();
            if (player.isInstructor) {
                player.get_class_data_from_ARGA();
                player.generate_instructor_report_data();
            }

            player.generate_student_report($('[data-block_type=\'individual_student_results\']')[0]);

            // check if activity has been completed and if so check if
            // DS info has been saved (DSInfoSaved set to 1) and if not
            // then save student info again to DS

            // brb: It isn't going to hurt anything if we send the DS
            // info anytime the user opens the completed activity so just
            // to be safe, send it every time.

            // brb: actually, we shouldn't save the information again if
            // we don't need to because we are inviting more possible
            // errors with Activity Tracker
            if (player.ACTIVITY_COMPLETED) {

                //safe_log("activity is completed, checking if auto update of DS is needed");

                // brb: There is a chance that no information was saved
                // for the user in DS but the user completed all of the
                // ARGA questions. So we need to put this in a try/catch
                // (because trying to access player.ds.userData.scores
                // will throw an error if there is nothing saved in DS)
                // and set ds_info_saved to undefined so we can force an
                // auto update of DS.
                var ds_info_saved;
                try {
                    ds_info_saved = player.ds.userData.scores.DSInfoSaved;
                    //safe_log("DSInfoSaved = " + ds_info_saved);
                    //safe_log(player.ds.userData);
                } catch (e) {
                    // brb: set to undefined to force an auto save
                    //safe_log(e.message);
                    //safe_log("player.ds.userData.scores is undefined, setting ds_info_saved to undefined to force an auto update of DS");
                    ds_info_saved = undefined;
                }

                // brb: only call send_ds_info if the DSInfoSaved flag
                // is not set
                if (all_questions_in_activity_answered() && ds_info_saved === undefined) {
                    //if (all_questions_in_activity_answered()) {
                    //alert("Student data has not been saved completely in DS. Activity will attempt to automatically update. Do you want this to succeed or fail?");
                    // brb: for testing, allows us to intentionally trigger
                    // a fail on auto updating DS
                    /*
                    var AUTO_SAVE_MESG = "Your student data has not been saved completely in DS. The activity will attempt to automatically update it. Click OK to allow this to proceed or Cancel to make it intentionally fail.";

                    if (confirm(AUTO_SAVE_MESG) == true) {
                        INITIAL_DS_FAIL = false;
                        RETRY_DS_FAIL = false;
                        safe_log("auto update succeed");
                    } else {
                        INITIAL_DS_FAIL = true;
                        RETRY_DS_FAIL = true;
                        safe_log("auto update fail");
                    }
                    */

                    //safe_log("DSInfoSaved flag is NOT set, need to call send_ds_info(0) to update student data in DS");
                    //safe_log(JSON.stringify(player.ds.userData));
                    send_ds_info(0);
                } else {
                    //safe_log("DSInfoSaved flag is set, no need to call send_ds_info");
                }

            }

        });

        /* Accessibility fix: Add help nav if student is viewing */
        // CTC-10050: they don't want the help button any more
        /*
        if (!(player.isInstructor)) {
            var help_html = '<div class=\'help_nav\'>';
            help_html += '<button aria-label=\'Help\' id=\'student_help_button\' class=\'btn btn-sm btn-info\' type=\'button\' onclick=\'player.show_student_help();\'><span class=\'glyphicon glyphicon-question-sign\'></span> Help</button>';
            help_html += '</div>';
            $('#manuscript').prepend(help_html);
        }
        */

        this._super();

        //safe_log("isInstructor = " + player.isInstructor);



        // If this is a student and the activity has been assigned and is
        // past due then they get an error message
        if (!player.isInstructor && due_date_has_passed()) {
            alert('The due date for this assignment has passed.');
        }

        // We don't want instructors to get annoying error messages about being
        // passed due
        if (player.isInstructor) {
            //safe_log("setting restore_last_viewed_section to false for instructor");
            player.md.restore_last_viewed_section = false;
        }

        $('.question_submit_button').addClass('btn btn-primary btn-lg');

        if (due_date_has_passed()) {
            $('.question_submit_button').remove();
        }

        //player.get_user_data_from_ARGA();

        if (player.isInstructor) {
            $('.instructor_results_info').show();
            $('.instructor_nav').show();


            // this.get_class_data_from_ARGA();

            // player.generate_instructor_report_data();

            // brb: 2019-05-21: Instructor dashboard has moved to a separate 
            // activity
            //routie('home');
            Standard_Dialog.alert("This is the student inventory. To take ACES as a student, complete the questions to get your student report. To access the instructor reports, see the ACES Instructor Reports Dashboard in the ACES Instructor Resources and Reports unit.");


        } else {
            $('#student_help_button').show();
        }


        //initialize section completion status

        for (var i = 0; i < player.sections.length; i++) {

            var s = player.sections[i];
            // if the current section has any questions, see if they've all been answered
            var qs_to_check = [];
            s.jq.find('[data-type=question]').each(function(index, element) {
                var q_index = $(element).attr('data-question_index');
                var question = player.activity.questions[q_index];
                s.all_questions_answered = s.all_questions_answered && question.is_complete();
                if (question.question_sequence != null) {
                    for (var i = 0; i < qs_to_check.length; ++i) {
                        if (qs_to_check[i] == question.question_sequence) break;
                    }
                    if (i == qs_to_check.length) {
                        qs_to_check.push(question.question_sequence);
                    }
                }
            });

        }



        this.update_progress_bar();

        /*
        $("#save_ds_info").click(function() {
            send_ds_info(0);
        });

        $("#calculate_scores").click(function() {

            var measure = parseInt($("#measure_limit").val());
            if (measure < 2 && measure > 13) {
                calculate_measure_scores();
            }
            else {
                calculate_measure_scores(measure);
            }
        });
        */

        /*
        $("#check_save").click(function() {
            if ($('#ds_save_cb_1').length == 1) {
                safe_log($("#ds_save_cb_1")[0].checked);
                safe_log($("#ds_save_cb_1"));
                safe_log($("#ds_save_cb_1")[0]);
            }
            else {
                safe_log("Can't find checkbox");
            }
        });
        */

    },

    update_progress_bar: function() {


        if (player.get_current_section() != null) {
            var currentindex = player.get_current_section().index;


            $('[data-block_type=survey_page]').each(function(index, element) {

                var section_index = $(element).attr('data-section-index') * 1;

                if (section_index < currentindex) {

                    $('#student_progress_box_' + section_index).addClass('completed');
                } else {
                    $('#student_progress_box_' + section_index).removeClass('completed');
                }

            });



        }


    }

});



player = new Player_gore();


/*
  inPX: Return true if the page is being viewed in PX, otherwise return false.

*/

xBookUtils.inPX = function() {

    if (xBookUtils.inPXFrame()) {
        return true;
    }
    // We could still be in a supp window in PX, so check the URL.
    // P.S. Not sure if this is the most reliable way to check this?
    if (/dlap\.bfwpub\.com/.test(window.location.href)) {
        return true;
    }
    if (/macmillanhighered\.com\/brainhoney/.test(window.location.href)) {
        return true;
    }
    return false;
};


/*
  inPXFrame: Return true if the page is being viewed in the main PX content frame,
  otherwise return false.
*/

xBookUtils.inPXFrame = function() {

    try {
        if (top.PxPage) {
            return true;
        }
    } catch (err) {}
    return false;
};



//to not show the letters for MC choices

CB_Query = CB_Query.extend({

    user_has_answered: function() {
        return true;
    }
});

MC_Query = MC_Query.extend({

    query_text_html_mc: function() {

        if (this.query_text != '' && this.md._hide_query_text != 'true') {
            // replace newlines with <br />
            var qt = jQuery.trim(this.query_text).replace(/\n/g, '<br>');
            return '<legend class=\'query_text\'>' + qt + '</legend>';
        } else {
            return '';
        }
    },

    user_has_answered: function() {
        if (typeof $('input:radio[name=query_answer_' + this.query_index + ']:checked').val() != 'undefined') {
            return true;
        } else {
            return false;
        }


    },
    // mode should be "delivery" or "review"; "delivery" is assumed
    getHTMLOld: function(mode) {
        // initialize imagemap elements
        if (this.imagemap_initialized === false) {
            var question_jq = this.jq.parent();
            this.im_init(question_jq);
            this.imagemap_initialized = true;
        }

        // start with the query text, if there
        var html = this.query_text_html();

        // wrap answers in a p tag
        html += '<p>';

        // Build answer selection
        var is_correct = false;
        for (var z = 0; z < this.choices.length; z++) {
            var index = this.choice_order[z];
            // if this is review mode...
            var checked = '';
            var disabled = '';
            var radio_style = 'query_mc_other_choice';
            if (mode == 'review' || mode == 'review_correct_incorrect' || mode == 'preview') {
                // if it's the correct choice, it should be marked in green
                if (index == this.correct_answer_index) {
                    // but only if we're *not* in review_correct_incorrect mode or this is the user's choice
                    if (mode != 'review_correct_incorrect' || index == this.user_answer_index) {
                        radio_style = 'query_mc_correct_choice';
                    }

                    // if this is what the user chose, he got it correct
                    if (index == this.user_answer_index) {
                        is_correct = true;
                    }

                    // else if it's the user's choice (and this.md.no_correct_answer is not true), it should be marked in red
                } else if (index == this.user_answer_index && this.md.no_correct_answer != 'true') {
                    radio_style = 'query_mc_incorrect_user_choice';
                }

                // and the input should be disabled, unless we're in review_correct_incorrect mode
                if (mode != 'review_correct_incorrect') {
                    disabled = 'disabled';
                }
            }

            // if this is the choice the user clicked, it's checked (regardless of mode)
            if (index == this.user_answer_index) {
                checked = 'checked';
            }

            // Create radio button input plus label
            html += '<table class=\'query_mc_choice_table\' border=\'0\' cellpadding=\'0\' cellspacing=\'0\'><tr>' +
                '<td><div class=\'' + radio_style + '\'>' +
                '<input class=\'query_mc_choice_radio\' type=\'radio\' name=\'query_answer_' + this.query_index + '\' ' +
                ' id=\'query_answer_' + this.query_index + '_' + index + '\' ' +
                ' value=\'' + index + '\' ' +
                checked + ' ' +
                disabled + ' ' +
                ' /></div></td>'
                //+ "<td>" + this.choice_ids[z] + ".</td>"
                +
                '<td><label id=\'query_answer_label_' + this.query_index + '_' + index + '\' ' +
                ' for=\'query_answer_' + this.query_index + '_' + index + '\'>' +
                this.choices[index] +
                '</label></td>' +
                '</tr></table>';
        }

        // get a possible feedback string; this fn will take account of mode
        html += this.correct_incorrect_feedback(mode, is_correct);

        html += '</p><div style=\'clear:both;\'></div>';

        return html;
    },

    // mode should be "delivery" or "review"; "delivery" is assumed

    getHTML: function(mode) {

        // initialize imagemap elements

        if (this.imagemap_initialized === false) {

            var question_jq = this.jq.parent();

            this.im_init(question_jq);

            this.imagemap_initialized = true;

        }



        // start with the query text, if there

        var html = '<fieldset>';

        html += this.query_text_html_mc();



        // wrap answers in a p tag

        //html += "<p>";



        // Build answer selection

        var is_correct = false;

        for (var z = 0; z < this.choices.length; z++) {

            var index = this.choice_order[z];

            // if this is review mode...

            var checked = '';

            var disabled = '';

            var radio_style = 'query_mc_other_choice';

            if (mode == 'review' || mode == 'review_correct_incorrect' || mode == 'preview') {

                // if it's the correct choice, it should be marked in green

                if (index == this.correct_answer_index) {

                    // but only if we're *not* in review_correct_incorrect mode or this is the user's choice

                    if (mode != 'review_correct_incorrect' || index == this.user_answer_index) {

                        radio_style = 'query_mc_correct_choice';

                    }



                    // if this is what the user chose, he got it correct

                    if (index == this.user_answer_index) {

                        is_correct = true;

                    }



                    // else if it's the user's choice (and this.md.no_correct_answer is not true), it should be marked in red

                } else if (index == this.user_answer_index && this.md.no_correct_answer != 'true') {

                    radio_style = 'query_mc_incorrect_user_choice';

                }



                // and the input should be disabled, unless we're in review_correct_incorrect mode

                if (mode != 'review_correct_incorrect') {

                    disabled = 'disabled';

                }

            }



            // if this is the choice the user clicked, it's checked (regardless of mode)

            if (index == this.user_answer_index) {

                checked = 'checked';

            }



            // Create radio button input plus label

            //html += "<table class='query_mc_choice_table' border='0' cellpadding='0' cellspacing='0'><tr>"

            //+ "<td><div class='" + radio_style + "'>"

            html += '<span class=\'mc_option\'><input class=\'query_mc_choice_radio\' type=\'radio\' name=\'query_answer_' + this.query_index + '\' '

                +
                ' id=\'query_answer_' + this.query_index + '_' + index + '\' '

                +
                ' value=\'' + index + '\' '

                +
                checked + ' '

                +
                disabled + ' '

                +
                ' />'

                //+ "<td>" + this.choice_ids[z] + ".</td>"

                +
                '<label id=\'query_answer_label_' + this.query_index + '_' + index + '\' '

                +
                ' for=\'query_answer_' + this.query_index + '_' + index + '\'>'

                +
                this.choices[index]

                +
                '</label></span>';

            //+ "</tr></table>";

        }

        html += '</fieldset>';


        // get a possible feedback string; this fn will take account of mode

        // no feedback for this quiz
        //html += this.correct_incorrect_feedback(mode, is_correct);



        //html += "</p>";



        return html;

    }

});



var FB_Query = FB_Query.extend({

    getHTML: function(mode) {
        var html = '';

        // start with the query text, if there is any
        html += this.query_text_html();

        // determine how big the response blank should be, unless one was specified
        var blank_size = this.md.blank_size;
        if (blank_size == '' || blank_size == null || isNaN(blank_size * 1)) {
            var s = '' + this.correct_answer;
            blank_size = (s.length + 2);
        }

        // if student hasn't answered or we're in preview mode, use an empty string for the input value
        var val, disabled;
        var fb_string = '';
        if (!this.userHasAnswered() || mode == 'preview') {
            val = '';
            disabled = '';

            // otherwise we have an answer, so fill it in
        } else {
            // make sure we convert double quotes to &#34; for placement in 'value="xxx"' attributes
            val = this.user_answer.replace(/\"/g, '&#34;');

            // also disable the input in this case, if we're not in review_correct_incorrect mode
            // or if the user got it right
            if (mode != 'review_correct_incorrect' || this.isCorrect()) {
                disabled = 'disabled';
            }
        }

        html += '<span style="white-space:nowrap">' +
            '<input title="Enter numbers only" pattern="[0-9]{1,4}" type="text" class="query_fb_input" id="query_answer_' + this.query_index + '" maxlength="' + blank_size + '" size="' + blank_size + '" value="' + val + '" ' + disabled + ' />';
        html += this.finish_inline_query(this.correct_answer, mode);

        html += '</span>';

        return html;
    },

    user_has_answered: function() {
        var $ques = $('#query_answer_' + this.query_index);
        var ans = $ques.val();

        if (ans === '0' || ans === '00' || ans === '000' || ans === '0000') {
            $ques.val('0');
            return true;
        }

        if (ans.length !== 4) {
            //safe_log("birth year was not 4 chars long");
            alert('Please enter a valid year for your birth year or 0 if you choose not to answer');
            return 'BAD_BIRTH_YEAR';
        }

        if (/[^0-9]/.test(ans)) {
            //safe_log("birth year has non-numeric characters");
            alert('Please enter a valid year for your birth year or 0 if you choose not to answer');
            return 'BAD_BIRTH_YEAR';
        }

        // convert string to num
        var ans_num = parseInt(ans);

        if (ans_num < 1900 || ans_num > 2006) {
            //safe_log("Invalid birth year entered [" + ans_num + "]");
            alert('Please enter a valid year for your birth year or 0 if you choose not to answer');
            return 'BAD_BIRTH_YEAR';
        }

        return true;
    }

});



var DD_Query = Query.extend({
    // ========================================
    // define and set defaults for variables specific to this query type
    choices: new Array(),
    choice_order: new Array(),
    correct_answer_index: null,
    user_answer_index: null,

    // ========================================
    // initialization
    parseSource: function() {
        // initialize vars
        this.choices = new Array();
        this.correct_answer_index = null;
        this.user_answer_index = null;

        // DD's are always one line only -- if query_text is specified, it's via metadata (see below)
        this.query_text = '';

        // the line might start with "DD:"; if so, strip it out
        var s = jQuery.trim(this.query_source.replace(/^DD:\s*/, ''));

        // if line ends with "~~\d+", that's points
        if (s.search(/(.*)~~([\.\d]+)$/) > -1) {
            s = RegExp.$1;
            this.points_possible = RegExp.$2;
        }

        // if the line starts with "!!", don't scramble
        if (s.substr(0, 2) == '!!') {
            this.md.never_scramble = 'true';

            // strip the !! out of answer
            s = s.replace(/^\!\!/, '');
        }

        // if the line ends with "??", any answer is correct
        if (s.substr(-2, 2) == '??') {
            this.md.no_correct_answer = 'true';

            // strip the ?? out of answer
            s = s.replace(/\?\?$/, '');
        }

        // if any commas were sent in as "\,", turn them into &#44;
        s = s.replace(/\\,/g, '&#44;');

        // likewise, turn "\*" into &#42;
        s = s.replace(/\\\*/g, '&#42;');

        // we might have &#34;'s indicating double quotes in the answers;
        // convert these to actual double quotes so that they display properly (though it might not matter)
        s = s.replace(/\&#34;/g, '"');

        // answer string should be something like "choice 1, choice2, *correct choice"
        // so split it and find the correct answer
        var answers = s.split(/,\s*/);
        var correctChoice = -1;
        for (var i = 0; i < answers.length; ++i) {
            var ans = answers[i];

            // look for points...
            if (ans.search(/^_points:\s*(\d+)/i) > -1) {
                this.points_possible = RegExp.$1;

                // skip to the next answer
                continue;

                // or query text
            } else if (ans.search(/^_query_text:\s*(.*)/i) > -1) {
                this.query_text = RegExp.$1;

                // skip to the next answer
                continue;


                // or metadata -- starts with "_[a-zA-Z]"
            } else if (ans.search(/^\_[a-zA-Z]/) > -1) {
                this.extractMetadata(ans);

                // skip to the next answer
                continue;

                // if we've found the correct answer...
            } else if (ans.substr(0, 1) == '*') {
                // if we already got a correctChoice, there's an error
                if (this.correct_answer_index != null) {
                    return '<b>error in pulldown answer (too many correct answers): ' + s + '</b>';
                }

                // otherwise this one is correct
                this.correct_answer_index = i;

                // strip the leading *
                ans = ans.substr(1);
            }

            // convert &#42;s to literal *'s now; also convert commas
            ans = ans.replace(/\&#42;/g, '*');
            ans = ans.replace(/\&#44;/g, ',');

            // transfer to choices, trimming in the process
            this.choices.push(jQuery.trim(ans));
        }

        // note: answers will be coded 0, 1, 2, 3, etc., with correctChoice numbered accordingly
        // (e.g. if first answer is correct, correctChoice is 0)

        // if we didn't get a correct choice, or if there aren't enough items,
        // that's an error
        if (this.correct_answer_index == null) {
            return '<b>error in pull down answer (no correct answer specified): ' + s + '</b>';
        } else if (this.choices.length <= 1) {
            return '<b>error in pulldown answer (0 or 1 choices specified): ' + s + '</b>';
        }

        // shuffle choices, unless md.never_scramble is true
        this.choice_order = new Array();
        for (var j = 0; j < this.choices.length; ++j) this.choice_order[j] = j;
        if (this.md.never_scramble != 'true') {
            this.choice_order.shuffle();
        }

        // deal with error handling...
    },

    // ========================================
    // extend query functions

    setQueryData: function(qd) {
        this._super(qd);

        // for DD queries, if we get query_data, that's the user's answer index
        if (qd != '' && qd != null && !isNaN(qd * 1)) {
            this.user_answer_index = qd * 1;
        }
    },

    restoreAnswerFromARGA: function(answer) {
        // find the choice that the user gave
        for (var i = 0; i < this.choices.length; ++i) {
            if (this.choices[i] == answer) {
                this.user_answer_index = i;
                return;
            }
        }
    },

    getQueryTypeForARGA: function() {
        return 'drop-down';
    },

    getCorrectAnswerForARGA: function() {
        return this.choices[this.correct_answer_index];
    },

    getUserAnswerForARGA: function() {
        if (this.user_answer_index == null || this.choices[this.user_answer_index] == null) {
            return 'Not answered';
        } else {
            return this.choices[this.user_answer_index];
        }
    },

    // mode should be "delivery" or "review" or "review_correct_incorrect"; "delivery" is assumed
    getHTML: function(mode) {
        var html = '';

        // DD's never have query text
        // Start a nobr tag for the item
        html = '<div class="row"><div class="query_dd_select_span col-lg-6">';

        // if we're in preview mode or
        // (a student answer has been given and we're not in review_correct_incorrect mode),
        // or the student got it correct
        // disable the select
        var disabled = '';
        if (mode == 'preview' || (mode != 'review_correct_incorrect' && this.user_answer_index != null) || this.isCorrect()) {
            disabled = 'disabled';
        }

        html += '<select class="query_dd_select form-control" id="query_answer_' + this.query_index + '" ' + disabled + '>';
        //+ '<option value="-1">--------</option>'

        for (var j = 0; j < this.choices.length; ++j) {
            var index = this.choice_order[j];
            var selected = '';
            // select the student answer, unless we're in preview mode
            if (this.user_answer_index == index && mode != 'preview') {
                selected = 'selected';
            }
            html += '<option value="' + index + '" ' + selected + '>' + this.choices[index] + '</option>';
        }
        html += '</select>';
        html += this.finish_inline_query(this.choices[this.correct_answer_index], mode);

        // Close off the nobr tag for the item
        html += '</div></div>';

        return html;
    },

    evaluateAnswer: function() {
        // get the user's selected answer, which will be 0-based
        this.user_answer_index = $('#query_answer_' + this.query_index).val() * 1;

        // set grade accordingly (if this.md.no_correct_answer is true, any answer is correct)
        if (this.user_answer_index == this.correct_answer_index || this.md.no_correct_answer == 'true') {
            this.setGrade(100);
        } else {
            this.setGrade(0);
        }

        return true;
    },
    user_has_answered: function() {
        var x = $('#query_answer_' + this.query_index).val();
        if ($('#query_answer_' + this.query_index).val() != -1) {
            return true;
        } else {
            return false;
        }


    }
});


// if a due date has been set and has passed then return 1, otherwise return 0
function due_date_has_passed() {
    if (player.ARGA_running) {
        if (Get_ARGA_Data('due_date_has_passed')) {
            return 1;
        } else {
            return 0;
        }
    } else {
        return 0;
    }
}


/*!
 * routie - a tiny hash router
 * v0.3.2
 * http://projects.jga.me/routie
 * copyright Greg Allen 2013
 * MIT License
 */
(function(n) {
    var e = [],
        t = {},
        r = 'routie',
        o = n[r],
        i = function(n, e) {
            this.name = e, this.path = n, this.keys = [], this.fns = [], this.params = {}, this.regex = a(this.path, this.keys, !1, !1);
        };
    i.prototype.addHandler = function(n) {
        this.fns.push(n);
    }, i.prototype.removeHandler = function(n) {
        for (var e = 0, t = this.fns.length; t > e; e++) {
            var r = this.fns[e];
            if (n == r) return this.fns.splice(e, 1), void 0;
        }
    }, i.prototype.run = function(n) {
        for (var e = 0, t = this.fns.length; t > e; e++) this.fns[e].apply(this, n);
    }, i.prototype.match = function(n, e) {
        var t = this.regex.exec(n);
        if (!t) return !1;
        for (var r = 1, o = t.length; o > r; ++r) {
            var i = this.keys[r - 1],
                a = 'string' == typeof t[r] ? decodeURIComponent(t[r]) : t[r];
            i && (this.params[i.name] = a), e.push(a);
        }
        return !0;
    }, i.prototype.toURL = function(n) {
        var e = this.path;
        for (var t in n) e = e.replace('/:' + t, '/' + n[t]);
        if (e = e.replace(/\/:.*\?/g, '/').replace(/\?/g, ''), -1 != e.indexOf(':')) throw Error('missing parameters for url: ' + e);
        return e;
    };
    var a = function(n, e, t, r) {
            return n instanceof RegExp ? n : (n instanceof Array && (n = '(' + n.join('|') + ')'), n = n.concat(r ? '' : '/?').replace(/\/\(/g, '(?:/').replace(/\+/g, '__plus__').replace(/(\/)?(\.)?:(\w+)(?:(\(.*?\)))?(\?)?/g, function(n, t, r, o, i, a) {
                return e.push({
                    name: o,
                    optional: !!a
                }), t = t || '', '' + (a ? '' : t) + '(?:' + (a ? t : '') + (r || '') + (i || r && '([^/.]+?)' || '([^/]+?)') + ')' + (a || '');
            }).replace(/([\/.])/g, '\\$1').replace(/__plus__/g, '(.+)').replace(/\*/g, '(.*)'), RegExp('^' + n + '$', t ? '' : 'i'));
        },
        s = function(n, r) {
            var o = n.split(' '),
                a = 2 == o.length ? o[0] : null;
            n = 2 == o.length ? o[1] : o[0], t[n] || (t[n] = new i(n, a), e.push(t[n])), t[n].addHandler(r);
        },
        h = function(n, e) {
            if ('function' == typeof e) s(n, e), h.reload();
            else if ('object' == typeof n) {
                for (var t in n) s(t, n[t]);
                h.reload();
            } else e === void 0 && h.navigate(n);
        };
    h.lookup = function(n, t) {
        for (var r = 0, o = e.length; o > r; r++) {
            var i = e[r];
            if (i.name == n) return i.toURL(t);
        }
    }, h.remove = function(n, e) {
        var r = t[n];
        r && r.removeHandler(e);
    }, h.removeAll = function() {
        t = {}, e = [];
    }, h.navigate = function(n, e) {
        e = e || {};
        var t = e.silent || !1;
        t && l(), setTimeout(function() {
            window.location.hash = n, t && setTimeout(function() {
                p();
            }, 1);
        }, 1);
    }, h.noConflict = function() {
        return n[r] = o, h;
    };
    var f = function() {
            return window.location.hash.substring(1);
        },
        c = function(n, e) {
            var t = [];
            return e.match(n, t) ? (e.run(t), !0) : !1;
        },
        u = h.reload = function() {
            for (var n = f(), t = 0, r = e.length; r > t; t++) {
                var o = e[t];
                if (c(n, o)) return;
            }
        },
        p = function() {
            n.addEventListener ? n.addEventListener('hashchange', u, !1) : n.attachEvent('onhashchange', u);
        },
        l = function() {
            n.removeEventListener ? n.removeEventListener('hashchange', u) : n.detachEvent('onhashchange', u);
        };
    p(), n[r] = h;
})(window);



/* brb: global functions */

// returns true if all questions in activity have been answered, otherwise
// returns false
function all_questions_in_activity_answered() {
    var all_answered = true;

    $('#manuscript').find('[data-type=question]').each(function() {
        var q_index = $(this).attr('data-question_index');
        var question = player.activity.questions[q_index];
        if (!question.is_complete()) {
            all_answered = false;
            return false;
        }
    });

    return all_answered;
}

// brb: Send the completed object to DS (only call this after all questions
// have been answered!) This function ensures that the correct up-to-date
// info is sent to DS after all questions have been answered.

// brb: initial (required) will be set to 1 if this function is called for
// the first time from submit_quesiton (if not set to 1 then this means
// that the function is being called automatically when the student opens
// the activity in order to update the student info in DS)
// brb: retry arg will be set to 1 if this is a retry of a failed attempt
function send_ds_info(initial, retry) {

    if (!player.ARGA_running) {
        return;
    }

    if (retry != 1) {
        retry = 0;
    }

    //safe_log("send_ds_info: initial = " + initial + ", retry = " + retry);

    // If user hasn't answered all the questions in the activity then
    // we can't do this.
    if (!all_questions_in_activity_answered()) {
        //safe_log('send_ds_info: not all questions in activity answered, not saving student info to DS');
        return;
    }

    //safe_log(player.ds.userData);

    // get the current isComplete flag
    var isComplete;

    // if this is the first time this function is called then isComplete is
    // always 0
    if (initial == 1) {
        isComplete = 0;
    }
    // otherwise, pull isComplete from DS
    else {
        try {
            isComplete = player.ds.userData.scores.isComplete;
        } catch (err) {
            // if we couldn't get isComplete from DS then make it 0 because
            // it won't hurt anything to send this information again to DS
            isComplete = 0;
        }
    }
    //safe_log("isComplete = " + isComplete);

    var data = {};

    function getIndexFromMeasureKey(key) {

        for (var i = 0; i < player.measure_names.length; i++) {
            if (player.measure_names[i].key == key) {
                return i;
            }
        }
        return -1;

    }

    function getIndexFromMeasureKeyNew(key) {
        for (var i = 0; i < player.measure_names_new.length; i++) {
            if (player.measure_names_new[i].key == key) {
                return i;
            }
        }
        return -1;
    }

    // reset measure scores to 0
    for (var z = 0; z < player.measure_names.length; z++) {
        player.measure_names[z].score = 0;
    }

    // new measures
    for (var z_new = 0; z < player.measure_names_new.length; z_new++) {
        player.measure_names_new[z_new].score = 0;
    }

    safe_log('send_ds_info:');
    safe_log('measure_names: ', JSON.stringify(player.measure_names));
    safe_log('measure_names_new: ', JSON.stringify(player.measure_names_new));


    for (var question_index = 1; question_index < 11; question_index++) {
        for (var i = 0; i < player.activity.questions[question_index].queries.length; i++) {

            var q = player.activity.questions[question_index].queries[i];

            // brb: If this question has a 'measure' associated with it
            // then add it to the running measure counter
            if (typeof q.md.measure != 'undefined') {

                var combined_measures = q.md.measure;
                var measures = combined_measures.split(',');
                var measure = measures[0];
                var measure_new = measures[1];
                var reverse = false;
                if (typeof q.md.reverse_score != 'undefined') {
                    if (q.md.reverse_score == 'true') {
                        reverse = true;
                    }
                }

                var index = getIndexFromMeasureKey(measure);
                var index_new = getIndexFromMeasureKeyNew(measure_new);

                if (reverse) {

                    player.measure_names[index].score = player.measure_names[index].score + (6 - player.activity.questions[question_index].queries[i].user_answer_index);

                    player.measure_names_new[index_new].score = player.measure_names_new[index_new].score + (6 - player.activity.questions[question_index].queries[i].user_answer_index);

                } else {

                    player.measure_names[index].score = player.measure_names[index].score + player.activity.questions[question_index].queries[i].user_answer_index + 1;

                    player.measure_names_new[index_new].score = player.measure_names_new[index_new].score + player.activity.questions[question_index].queries[i].user_answer_index + 1;

                }

            }

            // brb: otherwise the question is a demographic question
            // (last slide of the activity)
            if (typeof q.md.demographic != 'undefined') {

                if (q.md.demographic === 'Birth year') {

                    // The following commented code was used when "Birth year" was
                    // changed to a text input box.  We are going back to a dropdown.
                    /*
                      if (q.user_answer === "0") {
                      player.demographic_data[q.md.demographic] = "I choose not to answer this question";
                      }
                      else {
                      player.demographic_data[q.md.demographic] = q.user_answer;

                      }
                      //safe_log(q.md.demographic + " = " + player.demographic_data[q.md.demographic]);
                      */
                    player.demographic_data[q.md.demographic] = q.choices[q.user_answer_index].replace(',', '');
                    //safe_log(q.md.demographic + " = " + player.demographic_data[q.md.demographic]);
                } else {
                    player.demographic_data[q.md.demographic] = q.choices[q.user_answer_index].replace(',', '');
                    //safe_log(q.md.demographic + " = " + player.demographic_data[q.md.demographic]);
                }
            }
        } // end inner for
    } // end outer for

    //safe_log("player.measure_names (after):");
    //safe_log(JSON.stringify(player.measure_names));

    var scoreObject = {};
    var scoreObject_new = {};

    // loop through each entry in measure_names array
    for (var i = 0; i < player.measure_names.length; i++) {

        var score = 0;

        // get the score for the measure
        score = player.measure_names[i].score;

        // set scoreObject.key to score
        scoreObject[player.measure_names[i].key] = score;

    }

    // loop through each entry in measure_names_new array
    for (var i = 0; i < player.measure_names_new.length; i++) {

        var score_new = 0;

        // get the score for the measure
        score_new = player.measure_names_new[i].score;

        // set scoreObject.key to score
        scoreObject_new[player.measure_names_new[i].key] = score_new;

    }

    //safe_log("scoreObject");
    //safe_log(scoreObject);

    // sanity check for

    //data services:
    var dataObject = {};
    dataObject.name = Get_ARGA_Data('learner_name');

    var today = new Date();
    var dd = String(today.getDate()).padStart(2, '0');
    var mm = String(today.getMonth() + 1).padStart(2, '0'); //January is 0!
    var yyyy = today.getFullYear();
    var today = mm + '/' + dd + '/' + yyyy;

    dataObject.assessmentDate = today;

    // brb: we aren't using the completion status anywhere so no use
    // in saving it
    //dataObject.completion = Get_ARGA_Data("completion");
    //dataObject.scores = data;
    dataObject.scores = scoreObject;
    dataObject.scores_new = scoreObject_new;
    dataObject.demographics = player.demographic_data;
    dataObject.isComplete = 1;
    // this flag signals that we have completed the final save with
    // this function and therefore don't need to save the information
    // again.
    dataObject.DSInfoSaved = 1;

    // add instructor flag
    var courseOwner = getPXCourseOwnerID();
    var currentUser = getPXCurrentUserID();
    if (courseOwner !== undefined && currentUser !== undefined &&
        courseOwner === currentUser) {
        dataObject.isInstructor = 1;
    }
    else {
        dataObject.isInstructor = 0;
    }

    var record = player.ds.generateDataRecord('aces', 'scores', dataObject, 'true', 'true', 'false');

    //safe_log("send_ds_info: record");
    //safe_log(record);
    //safe_log("attempting to save DS data...");

    // brb: set to true for testing
    //DO_NOT_SAVE_DS = true;

    if (!DO_NOT_SAVE_DS) {
        //safe_log("saving data to DS");

        // brb: for testing
        /*
        var fail = false;

        // if this is the initial attempt and INITIAL_DS_FAIL is
        // set to true then we want to fail
        if (retry == 0) {
            if (INITIAL_DS_FAIL) {
                fail = true;
            }
        }
        // if this is the retry attempt and RETRY_DS_FAIL is
        // set to true then we want to fail
        else {
            if (RETRY_DS_FAIL) {
                fail = true;
            }
        }

        if (!fail) {
            window.parent.PX.API.DataService.setData = window.parent.PX.API.DataService.setDataOrig;
        }
        else {
            window.parent.PX.API.DataService.setData = window.parent.PX.API.DataService.setDataTest;
        }
        */

        player.ds.api.setData([record]).then(
            // success
            function(a) {
                safe_log("setData successful");
                safe_log(record);
                safe_log(a);
                // brb: we only want to show this message to the user if
                // they have entered the activity again after completing
                // all questions but their info was not saved to DS
                // brb: don't show it at all
                /*
                if (isComplete != 1 && initial != 1) {
                    alert("Your data has been saved to the course.");
                }
                */

                // we need to set this here in case student wants
                // to print their results immediately
                player.px_assessment_date = dataObject.assessmentDate;

                // if we are on the results page then we need to refresh
                // the page so it displays the correct numbers
                if (player.get_current_section().index == 11) {
                    //safe_log("current page is results page");
                    player.generate_student_report($('[data-block_type=\'individual_student_results\']')[0]);
                }

            },
            // failed
            function(a, b, c) {
                //safe_log("setData failed");

                // if this isn't a retry then wait a few seconds
                // and try again
                if (!retry) {
                    //safe_log("setData failed, retrying in 2 seconds");
                    //alert("setData failed, retrying in 2 seconds");
                    setTimeout(function() {
                        send_ds_info(initial, 1);
                    }, 2000);
                } else {
                    //if (isComplete != 1) {
                    alert('There was an error saving your data. Please exit out of this activity and then open it again to resume.');
                    brbDisableActivity('setData error', a, b, c);
                    //}
                }
            }
        );

        // brb: Adams's stuff that saves the scoreObject on
        // devlives.azurewebsites.net/api/ACESvalues/userID
        if (player.ARGA_running) {
            scoreObject.courseID = Get_ARGA_Data('course_id');
            player.sendModelToServer(scoreObject);
        }
    } else {
        safe_log('DO_NOT_SAVE_DS is true, not saving data to DS');
        //alert("Student info was not saved to Data Services.");
    }

}


// To be called if the connection to DS doesn't work.
// error_msg should always be a non-empty string
// a, b, c are optional additional error messages
function brbDisableActivity(error_mesg, a, b, c) {

    if (a !== undefined) {
        if (typeof a === 'object') {
            a = JSON.stringify(a);
        }
        error_mesg += '<br/>' + a;
    }
    if (b !== undefined) {
        if (typeof b === 'object') {
            b = JSON.stringify(b);
        }
        error_mesg += '<br/>' + b;
    }
    if (c !== undefined) {
        if (typeof c === 'object') {
            c = JSON.stringify(c);
        }
        error_mesg += '<br/>' + c;
    }

    // brb: they do not want to show technical errors to users

    if ($('#ds_fail').length < 1) {
        //$("#manuscript").html("<p id='ds_fail'>Please exit out of this activity and then open it again to resume.</p><p>" + error_mesg + "</p>");
        $('#manuscript').html('<p id=\'ds_fail\'>Please exit out of this activity and then open it again to resume.</p>');
    }
    /*
    else {
        $("#manuscript").append("<p>" + error_mesg + "</p>");
    }
    */

    window.parent.PX.API.DataService.setData = window.parent.PX.API.DataService.setDataOrig;

}


function calculate_measure_scores(meas_num) {


    function getIndexFromMeasureKey(key) {

        for (var i = 0; i < player.measure_names.length; i++) {
            if (player.measure_names[i].key == key) {
                return i;
            }
        }
        return -1;

    }

    // reset measure scores to 0
    for (var z = 0; z < player.measure_names.length; z++) {
        player.measure_names[z].score = 0;
    }

    var q_num = 0;

    for (var question_index = 1; question_index < 10; question_index++) {
        for (var i = 0; i < player.activity.questions[question_index].queries.length; i++) {

            q_num++;

            var q = player.activity.questions[question_index].queries[i];

            // brb: If this question has a 'measure' associated with it
            // then add it to the running measure counter
            if (typeof q.md.measure != 'undefined') {

                var measure = q.md.measure;
                var reverse = false;
                if (typeof q.md.reverse_score != 'undefined') {
                    if (q.md.reverse_score == 'true') {
                        reverse = true;
                    }
                }

                var index = getIndexFromMeasureKey(measure);

                if (meas_num === undefined || meas_num == measure) {

                    //safe_log('question ' + q_num);

                    //safe_log('measure = ' + measure + ', index = ' + index);

                    //safe_log('CURRENT player.measure_names[' + index + '].score = ' + player.measure_names[index].score);

                    //safe_log('user_answer index = ' + player.activity.questions[question_index].queries[i].user_answer_index);

                }

                if (reverse) {

                    if (meas_num === undefined || meas_num == measure) {
                        //safe_log('score added is REVERSED: ' + (6 - player.activity.questions[question_index].queries[i].user_answer_index));
                    }

                    player.measure_names[index].score = player.measure_names[index].score + (6 - player.activity.questions[question_index].queries[i].user_answer_index);

                } else {

                    if (meas_num === undefined || meas_num == measure) {
                        //safe_log('score added is: ' + (player.activity.questions[question_index].queries[i].user_answer_index + 1));
                    }

                    player.measure_names[index].score = player.measure_names[index].score + player.activity.questions[question_index].queries[i].user_answer_index + 1;

                }

                if (meas_num === undefined || meas_num == measure) {
                    //safe_log('NEW player.measure_names[' + index + '].score = ' + player.measure_names[index].score);
                }

            } else {
                //safe_log('OOPS, no measure defined for question');
            }

        }
    }

    var scoreObject = {};

    // loop through each entry in measure_names array
    for (var i = 0; i < player.measure_names.length; i++) {

        var score = 0;

        // get the score for the measure
        score = player.measure_names[i].score;

        // set scoreObject.key to score
        scoreObject[player.measure_names[i].key] = score;

    }

    //safe_log(JSON.stringify(scoreObject));


}

var KEYCODES = {
    ENTER: 13,
    TAB: 9,
    ESC: 27,
    SPACE: 32,
    LEFT: 37,
    RIGHT: 39
  };

  /*
  var Standard_Dialog = function() {
    var $manuscript = $('#manuscript');
    var $body = $('body');
    var $dialog, $content;
    var options = {};
  
    return {
      open: function(html, opt) {
        // Extend default options
        options = $.extend(true, {
          width: 450,
          modal: true,
          draggable: false,
          resizable: false,
          ariaLabelledby: null,
          ariaDescribedby: ''
        }, (opt || {}));
  
        // Set buttons
        if (options.buttons === 'none') {
          options.buttons = null;
        }
        else if (options.buttons === 'OK' || !options.buttons) {
          options.buttons = [ { text: 'OK', click: Standard_Dialog.close } ];
        }
  
        // Remove previous dialog
        //$('#standard_dialog_div').dialog('close').remove();
        $('#standard_dialog_div').remove();

        if (options.modal) {
          $body.css('overflow', 'hidden');
        }
  
        // Hide other content from reader for mobile devices
        $manuscript.attr('aria-hidden', 'true');
  
        $dialog = $('<div id="standard_dialog_div"></div>');
        $content = $('<div class="dialog-div">' + (html || '') + '</div>');
  
        $dialog.append($content);
        $dialog.dialog(options);
  
        // If we open toc we use as description only instruction in the top of dialog and not links
        var labelledByPart = 'standard_dialog_div';
  
        var labelledBy = options.ariaLabelledby === null ? 'ui-dialog-title-standard_dialog_div ' + labelledByPart : options.ariaLabelledby;
  
        // set so ugly, that don't break current functionality with aria-labelledby
        var $parentDialog = $dialog.parent().attr({
          'tabindex': '0',
          'role': 'dialog'
        });
        var _labeledBy = labelledBy;
        var _descrBy = options.ariaDescribedby;
  
        _labeledBy && $parentDialog.attr('aria-labelledby', _labeledBy);
        _descrBy && $parentDialog.attr('aria-describedby', _descrBy);
  
        $parentDialog.find('#ui-dialog-title-standard_dialog_div').attr({
          'role': 'heading',
          'aria-level': '1'
        });
  
        // Remove close btn
        $('.ui-dialog-titlebar-close').remove();
  
        var $lastBtn = $parentDialog.find('button').last();
        var $firstBtn = $parentDialog.find('button').first();
  
        // Attach events
        $parentDialog.bind('keydown', function(e) {
          var code = e.keyCode || e.which;
  
          if (code === KEY_CODES.ESC) {
            //safe_log(options);
            if (typeof options.buttons[0].click === 'function') {
              options.buttons[0].click();
            }
            else {
              Standard_Dialog.close(true);
            }
          }
  
          if (e.target === this && e.shiftKey && code === KEY_CODES.TAB) {
            e.preventDefault();
            $lastBtn.focus();
          }
        });
        $lastBtn.bind('keydown', function(e) {
          var code = e.keyCode || e.which;
  
          if (!e.shiftKey && code === KEY_CODES.TAB) {
            $parentDialog.focus();
            e.preventDefault();
          }
        });
  
        // For other platform we set focus on first button
        $firstBtn.focus();
  
        $(document.head).parent().css('overflow', 'hidden');
      },
  
      // for now alert is just like any other dialog; we could change that later.
      wait: function(html, opt) {
        options = opt || {};
        options.buttons = 'none';
        Standard_Dialog.open(html, options);
      },
  
      alert: function(html, opt) {
        Standard_Dialog.open(html, opt);
      },
  
      close: function() {
        // Show other content
        $manuscript.removeAttr('aria-hidden');
  
        if ($dialog) {
          $dialog.dialog('close').remove();
        }
        else {
          $("#standard_dialog_div").remove();
        }
  
        if (options.from) {
          options.from.focus();
        }
  
        if (options.modal) {
          $body.css('overflow', 'auto');
        }
  
        $(document.head).parent().css('overflow', 'auto');
      }
    };
  }();
  */

  function getPXCourseOwnerID() {
    if (!xBookUtils.inPXFrame()) {
        return undefined;
    }
    try {
        return parent.PxPage.Context.Course.CourseOwner.Id;
    }
    catch(err) {
        //safe_log('getPXCourseOwnerID: ' + err.message);
        return undefined;
    }
  }
  function getPXCurrentUserID() {
    if (!xBookUtils.inPXFrame()) {
        return undefined;
    }
    try {
        return parent.PxPage.Context.User.CurrentUserId;
    }
    catch(err) {
        //safe_log('getPXCurrentUserID: ' + err.message);
        return undefined;
    }
  }
  function getPXTermId() {
    if (!xBookUtils.inPXFrame()) {
        return undefined;
    }
    try {
        var term_id = parent.PxPage.Context.Course.AcademicTerm;
        term_id = term_id.replace(/ /g, '');
        return term_id;
    }
    catch(err) {
        //safe_log('getPXTermId: ' + err.message);
        return undefined;
    }
  }
  